<?php
/**
 * @package   astec
 * @name      c_estoque_rel
 * @version   4.3
 * @copyright 2020
 * @link      http://www.admservice.com.br/
 * @author    
 * @date      18/05/2020
 */
$dir = dirname(__FILE__);
include_once($dir . "/../../bib/c_user.php");
include_once($dir . "/../../bib/c_date.php");
include_once($dir . "/../../bib/c_tools.php");
include_once($dir . "/../../class/crm/c_conta.php");

//Class C_PRODUTO
Class c_estoque_rel extends c_user {

/**
 * Função  where para consulta do relatorio de curva abc 
 * @param $sql, comando que ira ser concatenado 
 * baseados nos filtros [DataInicio, DataFim, Data Referencia, Cod Produto, Id Pessoa, 
 * Num NotaFiscal, CentroCusto e tipoCurvaABC ]
 * grupoProduto var a parte
 * @name where_curva_ABC
 * @return string sql concatenada com os filtros selecionados * 
 */
public function where_curva_ABC($sql){
    /*
    $this->m_par[0] = DataInicio
    $this->m_par[1] = DataFim
    $this->m_par[2] = Data Referencia
    $this->m_par[3] = Cod Produto
    $this->m_par[4] = Id Pessoa
    $this->m_par[5] = Num Nota Fiscal
    $this->m_par[6] = centrocusto
    $this->m_par[7] = tipoCurvaABC
    */ 
    $grupo   = explode("|", $this->m_grupo);
    $dataIni = c_date::convertDateTxt($this->m_par[0]);
    $dataFim = c_date::convertDateTxt($this->m_par[1]);
    $tipoCurvaAbc = $this->m_par[7];

    $cond = strpos($sql, 'where') === false ? 'where' : 'and';
    $sql .= empty($this->m_par[0]) ? '':" $cond (P.EMISSAO >= '$dataIni') ";

    $cond = strpos($sql, 'where') === false ? 'where' : 'and';
    $sql.=  empty($this->m_par[1]) ? '':" $cond (P.EMISSAO <= '$dataFim') ";

    $cond =  strpos($sql, 'where') === false ? 'where' : 'and';
    $sql .= empty($this->m_par[3]) ? '':" $cond (PRO.CODIGO = '".$this->m_par[3]."')";

    $cond = strpos($sql, 'where') === false ? 'where' : 'and';
    $sql .= empty($this->m_par[6]) ? '':" $cond (P.CCUSTO = '".$this->m_par[6]."') ";

    $grupos = '';
    for($i = 1; $i < count($grupo); $i++){
        $grupos .= "'".$grupo[$i]."',";
    }
    $grupos = strstr($grupos, ',', true);
    $cond =  strpos($sql, 'where') === false ? 'where' : 'and';
    $sql .= empty($grupos) ? '':" $cond (PRO.GRUPO IN (".$grupos.")) ";

    $sql .= "GROUP BY I.ITEMESTOQUE ";
    $sql .= "ORDER BY ".$tipoCurvaAbc. " DESC";

    return $sql;
}

/**
 * Consulta ao Banco para gerar o relatorio de curva ABC
 * baseados nos filtros [DataInicio, DataFim, Cod Produto, CentroCusto, Grupo de Produtos, 
 * tipoCurvaABC]
 * @name select_relatorio_curva_abc
 * @return ARRAY  os campos [CENTROCUSTO, ITEMESTOQUE, GRUPO, PRODUTO, CODFABRICACAO, QUANTMIN, 
 * VENDA, EMISSAO, SUM(QTSOLICITADA), SUM(I.TOTAL) COUNT(I.ID)] 
 */
public function select_relatorio_curva_abc(){
    $sql =  "SELECT P.CCUSTO, I.ITEMESTOQUE, G.DESCRICAO AS GRUPO, PRO.DESCRICAO, PRO.CODFABRICANTE, ";
    $sql .= "PRO.QUANTMINIMA, PRO.VENDA , P.EMISSAO, ";
    $sql .= "SUM(QTSOLICITADA) AS QUANT, ";
    $sql .= "SUM(I.TOTAL) AS VALOR, ";
    $sql .= "COUNT(I.ID) AS NUMVENDAS ";
    $sql .= "FROM FAT_PEDIDO P ";
    $sql .= "JOIN FAT_PEDIDO_ITEM I ON (P.ID = I.ID) ";
    $sql .= "JOIN EST_PRODUTO PRO ON (PRO.CODIGO = I.ITEMESTOQUE) ";
    $sql .= "JOIN EST_GRUPO G ON (G.GRUPO = PRO.GRUPO) ";
    
    $sql = $this->where_curva_ABC($sql);
    
    $banco = new c_banco();
    $banco->exec_sql($sql);
    $banco->close_connection();
    $result = $banco->resultado;
    return $result;
}

public function select_estoque_nf($codProd, $ccusto, $dataIni, $dataFim, $saldoInicial = NULL){

    $sql = "SELECT NFP.CODPRODUTO, NFP.DESCRICAO,
		            SUM(CASE WHEN NF.TIPO = 0 THEN NFP.QUANT END) AS ENTRADA, 
                    SUM(CASE WHEN NF.TIPO = 1 THEN NFP.QUANT END) AS SAIDA,
        CC.DESCRICAO AS CENTROCUSTO FROM EST_NOTA_FISCAL_PRODUTO NFP 
        LEFT JOIN EST_NOTA_FISCAL NF ON (NFP.IDNF = NF.ID)
        LEFT JOIN FIN_CENTRO_CUSTO CC ON (NF.CENTROCUSTO = CC.CENTROCUSTO) ";
        $sql .= "WHERE NFP.CODPRODUTO = '".$codProd."' ";
        $sql .= " AND (NF.CENTROCUSTO = '".$ccusto."') ";
        if($saldoInicial == true){
            $sql .= " AND (NF.DATASAIDAENTRADA < '$dataIni') ";
        }else{
        $sql .= "AND ((NF.DATASAIDAENTRADA >= '".$dataIni."') 
                 AND (NF.DATASAIDAENTRADA <= '".$dataFim."'))";
        }
        $banco = new c_banco();
        $banco->exec_sql($sql);
        $banco->close_connection();
        return $banco->resultado;
}

public function select_estoque_ped($codProd, $ccusto, $dataIni, $dataFim, $saldoInicial = NULL){
    
    $sql = "SELECT PI.ITEMESTOQUE, PI.DESCRICAO, 
                SUM(QTSOLICITADA) AS SAIDA, CCP.DESCRICAO AS CCUSTO  FROM FAT_PEDIDO_ITEM PI
        LEFT JOIN FAT_PEDIDO P ON (PI.ID = P.ID)
        LEFT JOIN FIN_CENTRO_CUSTO CCP ON (P.CCUSTO = CCP.CENTROCUSTO) ";
        $sql .= "WHERE PI.ITEMESTOQUE = '".$codProd."' ";
        $sql .= " AND (P.CCUSTO = '".$ccusto."') ";
        if($saldoInicial == true){
            $sql .= " AND (P.EMISSAO < '$dataIni') ";
        }else{
            $sql .= "AND ((P.EMISSAO >= '".$dataIni."') 
                 AND (P.EMISSAO <= '".$dataFim."'))";
        }
        

        $banco = new c_banco();
        $banco->exec_sql($sql);
        $banco->close_connection();
        return $banco->resultado;
}

/**
 * Consulta para o Banco atraves de parametros para gerar o relatorio de kardex sintetico
 * baseados nos filtros [DataInicio, DataFim, Data Referencia, Cod Produto, Id Pessoa, 
 * Num NotaFiscal, CentroCusto, Grupo de Produtos]
 * @name select_relatorio_kardex_sintetico
 * @return ARRAY todos os campos da table * 
 */
public function select_relatorio_kardex_sintetico($par, $grupo){
    /*
    $par[0] = DataInicio
    $par[1] = DataFim
    $par[2] = Data Referencia
    $par[3] = Cod Produto
    $par[4] = Id Pessoa
    $par[5] = Num Nota Fiscal
    $par[6] = centrocusto
    */ 
    $dataIni = c_date::convertDateTxt($par[0]) ;
    $dataFim = c_date::convertDateTxt($par[1]) ;

    $sql =  "SELECT PROD.CODIGO, PROD.DESCRICAO, G.DESCRICAO AS DESCGRUPO ";
    $sql .= "FROM EST_PRODUTO PROD ";
    $sql .= "LEFT JOIN EST_GRUPO G ON (PROD.GRUPO = G.GRUPO ) ";
    
  
    $cond =  strpos($sql, 'where') === false ? 'where' : 'and';
    $sql .= empty($par[3]) ? '':" $cond (PROD.CODIGO = $par[3]) ";

    $grupos = '';
    for($i = 1; $i < count($grupo); $i++){
        $grupos .= "'".$grupo[$i]."',";
    }
    $grupos = strstr($grupos, ',', true);
    $cond =  strpos($sql, 'where') === false ? 'where' : 'and';
    $sql .= empty($grupos) ? '':" $cond (PROD.GRUPO IN (".$grupos.")) ";
   
    $sql .= "GROUP BY PROD.CODIGO ";
    $banco = new c_banco();
    $banco->exec_sql($sql);
    $banco->close_connection();
    //return $banco->resultado;
    $result = $banco->resultado;

    for($i=0;$i < count($result); $i++){
        
        $nfResult = $this->select_estoque_nf($result[$i]['CODIGO'],$par[6], $dataIni, $dataFim);
        
        $pedResult = $this->select_estoque_ped($result[$i]['CODIGO'], $par[6], $dataIni, $dataFim);

        $entrada = (($nfResult[0]['ENTRADA']));
        $saida = (($nfResult[0]['SAIDA']) + ($pedResult[0]['SAIDA']));

        $saldo = ($entrada - $saida);

        $nfSaldoInicial = $this->select_estoque_nf($result[$i]['CODIGO'], $par[6], $dataIni, $dataFim, true);
        
        $pedSaldoInicial = $this->select_estoque_ped($result[$i]['CODIGO'], $par[6],$dataIni, $dataFim, true);

        $saldoInicial = ($nfSaldoInicial[0]['ENTRADA'] - ($nfSaldoInicial[0]['SAIDA'] + $pedSaldoInicial[0]['SAIDA']));
        
        $saldoAtual = ($saldoInicial + $saldo);
        $resp[$i] = [
            'CENTROCUSTO'   => $nfResult[0]['CENTROCUSTO'],
            'CODIGO'        => $result[$i]['CODIGO'],
            'DESCRICAO'     => $result[$i]['DESCRICAO'],
            'SALDO_INICIAL' => $saldoInicial,
            'QUANT_ENTRADA' => $entrada,
            'QUANT_SAIDA'   => $saida,
            'SALDO_ATUAL'   => $saldoAtual
        ];
    }

    return $resp;
}


/**
 * Consulta para o Banco atraves de parametros para gerar o relatorio de kardex Analitico
 * baseados nos filtros [DataInicio, DataFim, Data Referencia, Cod Produto, Id Pessoa, 
 * Num NotaFiscal, CentroCusto, Grupo de Produtos, Situação NotaFiscal, Tipo NotaFiscal]
 * @name select_relatorio_kardex
 * @return ARRAY todos os campos da table * 
 */
public function select_relatorio_kardex($par, $grupo, $sit, $tipo){
    /*
    $par[0] = DataInicio
    $par[1] = DataFim
    $par[2] = Data Referencia
    $par[3] = Cod Produto
    $par[4] = Id Pessoa
    $par[5] = Num Nota Fiscal
    $par[6] = Centro de Custo

    */ 
    $dataIni = c_date::convertDateTxt($par[0]) ;
    $dataFim = c_date::convertDateTxt($par[1]) ;

    $sqlE =  "SELECT IF (TIPO = 0, 'ENTRADA', 'SAIDA') AS TIPO, NF.DOC, NF.NUMERO, NF.DATASAIDAENTRADA AS DATAEMISSAO, CC.DESCRICAO AS CENTROCUSTO, PROD.CODIGO, PROD.DESCRICAO, NFP.QUANT AS QUANTIDADE, FC.NOMEREDUZIDO, FC.CNPJCPF ";
    $sqlE .= "FROM EST_PRODUTO PROD ";
    $sqlE .= "LEFT JOIN EST_NOTA_FISCAL_PRODUTO NFP ON (PROD.CODIGO = NFP.CODPRODUTO) ";
    $sqlE .= "LEFT JOIN EST_NOTA_FISCAL NF ON (NFP.IDNF = NF.ID) ";
    $sqlE .= "LEFT JOIN FIN_CENTRO_CUSTO CC ON (NF.CENTROCUSTO = CC.CENTROCUSTO) ";
    $sqlE .= "LEFT JOIN FIN_CLIENTE FC ON (FC.CLIENTE = NF.PESSOA) ";
    $sqlE .= "where (NF.SITUACAO='B') ";
    
    $cond =  strpos($sqlE, 'where') === false ? 'where' : 'and';
    $sqlE .= empty($par[0]) ? '':" $cond (NF.DATASAIDAENTRADA >= '$dataIni') ";

    $cond =  strpos($sqlE, 'where') === false ? 'where' : 'and';
    $sqlE .= empty($par[1]) ? '':" $cond (NF.DATASAIDAENTRADA <= '$dataFim') ";

    $cond =  strpos($sqlE, 'where') === false ? 'where' : 'and';
    $sqlE .= empty($par[3]) ? '':" $cond (PROD.CODIGO = $par[3]) ";

    $cond =  strpos($sqlE, 'where') === false ? 'where' : 'and';
    $sqlE .= empty($par[5]) ? '':" $cond (NF.NUMERO = $par[5]) ";

    $cond =  strpos($sqlE, 'where') === false ? 'where' : 'and';
    $sqlE .= empty($par[6]) ? '':" $cond (NF.CENTROCUSTO = '".$par[6]."') ";

    
    $sqlE .= "UNION ";

    $sqlS =  "SELECT 'SAIDA' AS TIPO, P.ID, P.ID AS NUMERO, P.EMISSAO AS DATAEMISSAO, CC.DESCRICAO AS CENTROCUSTO,PROD.CODIGO, PROD.DESCRICAO, PI.QTSOLICITADA AS QUANTIDADE, FC.NOMEREDUZIDO, FC.CNPJCPF ";
    $sqlS .= "FROM EST_PRODUTO PROD ";
    $sqlS .= "LEFT JOIN FAT_PEDIDO_ITEM PI ON (PROD.CODIGO = PI.ITEMESTOQUE) ";
    $sqlS .= "LEFT JOIN FAT_PEDIDO P ON (PI.ID = P.ID) ";
    $sqlS .= "LEFT JOIN FIN_CENTRO_CUSTO CC ON (P.CCUSTO = CC.CENTROCUSTO) ";
    $sqlS .= "LEFT JOIN FIN_CLIENTE FC ON (FC.CLIENTE = P.CLIENTE) ";
    $sqlS .= "where ((P.SITUACAO in ('6', '9'))) ";

    $cond =  strpos($sqlS, 'where') === false ? 'where' : 'and';
    $sqlS .= empty($par[0]) ? '':" $cond (P.EMISSAO >= '$dataIni') ";

    $cond =  strpos($sqlS, 'where') === false ? 'where' : 'and';
    $sqlS .= empty($par[1]) ? '':" $cond (P.EMISSAO <= '$dataFim') ";

    $cond =  strpos($sqlS, 'where') === false ? 'where' : 'and';
    $sqlS .= empty($par[3]) ? '':" $cond (PROD.CODIGO = $par[3]) ";

    $cond =  strpos($sqlS, 'where') === false ? 'where' : 'and';
    $sqlS .= empty($par[4]) ? '':" $cond (P.CLIENTE = $par[4]) ";

    $cond =  strpos($sqlS, 'where') === false ? 'where' : 'and';
    $sqlS .= empty($par[5]) ? '':" $cond (P.ID = $par[5]) ";

    $cond =  strpos($sqlS, 'where') === false ? 'where' : 'and';
    $sqlS .= empty($par[6]) ? '':" $cond (P.CCUSTO = '".$par[6]."') ";

    
    $sqlS .= "order by CODIGO, DATAEMISSAO, TIPO";

    $sql = $sqlE.$sqlS;
    //echo strtoupper($sql)."<br>";
    $banco = new c_banco();
    $banco->exec_sql($sql);
    $banco->close_connection();
    return $banco->resultado;
}

/**
 * Consulta para o Banco atraves de parametros para pegar o valor do SALDO INICIAL DE ENTRADA 
 * DO relatorio de kardex Analitico
 * baseados nos filtros [DataInicio e Cod Produto]
 * @name saldo_inicial_entrada
 * @return ARRAY com o valor do SALDO INICIAL DE ENTRADA * 
 */
public function saldo_inicial_entrada($dataIni, $codProduto){
    $dataInicio = c_date::convertDateTxt($dataIni); 

    $sql = "SELECT SUM(NFP.QUANT) AS QUANTIDADE
            FROM EST_NOTA_FISCAL_PRODUTO NFP ";
    $sql .= "INNER JOIN EST_NOTA_FISCAL NF ON (NFP.IDNF = NF.ID) ";

    $cond =  strpos($sql, 'where') === false ? 'where' : 'and';
    $sql .= empty($codProduto) ? '':" $cond (NFP.CODPRODUTO = $codProduto)";

    $cond =  strpos($sql, 'where') === false ? 'where' : 'and';
    $sql .= empty($dataInicio) ? '':" $cond (NF.DATASAIDAENTRADA < '$dataInicio') ";

    //echo strtoupper($sql)."<br>";
    $banco = new c_banco();
    $banco->exec_sql($sql);
    $banco->close_connection();
    return $banco->resultado;
}

/**
 * Consulta ao Banco atraves de parametros para pegar o valor do SALDO INICIAL DE SAIDA 
 * DO relatorio de kardex Analitico
 * baseados nos filtros [DataInicio e Cod Produto ]
 * @name saldo_inicial_saida
 * @return ARRAY com o valor do SALDO INICIAL DE SAIDA * 
 */
public function saldo_inicial_saida($dataIni, $codProduto){
    $dataInicio = c_date::convertDateTxt($dataIni); 
    $sql = "SELECT SUM(PI.QTSOLICITADA) AS QUANTIDADE
            FROM FAT_PEDIDO_ITEM PI ";
    $sql .= "INNER JOIN FAT_PEDIDO P ON (PI.ID = P.ID) ";

    $cond =  strpos($sql, 'where') === false ? 'where' : 'and';
    $sql .= empty($codProduto) ? '':" $cond (PI.ITEMESTOQUE = $codProduto)";

    $cond =  strpos($sql, 'where') === false ? 'where' : 'and';
    $sql .= empty($dataInicio) ? '':" $cond (P.EMISSAO < '$dataInicio') ";

    //echo strtoupper($sql)."<br>";
    $banco = new c_banco();
    $banco->exec_sql($sql);
    $banco->close_connection();
    return $banco->resultado;
}

/**
 * Consulta ao Banco atraves de parametros para obter as Entradas do movimento de ESTOQUE  
 * baseados nos filtros [dataIni, dataFim , centroCusto, CodProduto e grupo de Produto]
 * @name movimento_estoque_entrada
 * @return ARRAY com [IDNotaFiscal, CodProduto, DESCRICAO, ENTRADA, TOTAL_ENTRADA, DATA_ENTRADA  ]  
 */
public function movimento_estoque_entrada(){
    $grupo   = explode("|", $this->m_grupo);
    $dataIni = c_date::convertDateTxt($this->m_par[0]);
    $dataFim = c_date::convertDateTxt($this->m_par[1]);

    $sql =  "SELECT NFP.IDNF, NFP.CODPRODUTO, NFP.DESCRICAO, NFP.QUANT AS ENTRADA, NFP.TOTAL AS TOTAL_ENTRADA, NF.DATASAIDAENTRADA AS DATA_ENTRADA ";
    $sql .= "FROM EST_NOTA_FISCAL_PRODUTO NFP ";
    $sql .= "LEFT JOIN EST_NOTA_FISCAL NF ON (NFP.IDNF = NF.ID) ";
    $sql .= "LEFT JOIN EST_PRODUTO PROD ON (NFP.CODPRODUTO = PROD.CODIGO) ";
    $sql .= "where NF.TIPO = '0' ";

    $cond =  strpos($sql, 'where') === false ? 'where' : 'and';
    $sql .=  empty($dataIni) ? '':" $cond (NF.DATASAIDAENTRADA BETWEEN '".$dataIni."' AND '".$dataFim."') ";

    $cond =  strpos($sql, 'where') === false ? 'where' : 'and';
    $sql .= empty($this->m_par[3]) ? '':" $cond (PROD.CODIGO = '".$this->m_par[3]."') ";

    $cond = strpos($sql, 'where') === false ? 'where' : 'and';
    $sql .= empty($this->m_par[6]) ? '':" $cond (NF.CENTROCUSTO = '".$this->m_par[6]."') ";

    $grupos = '';
    for($i = 1; $i < count($grupo); $i++){
        $grupos .= "'".$grupo[$i]."',";
    }
    $grupos = strstr($grupos, ',', true);
    $cond =  strpos($sql, 'where') === false ? 'where' : 'and';
    $sql .= empty($grupos) ? '':" $cond (PROD.GRUPO IN (".$grupos.")) ";

   
    $sql .= "ORDER BY NF.DATASAIDAENTRADA ";
    $banco = new c_banco();
    $banco->exec_sql($sql);
    $banco->close_connection();
    return $banco->resultado;
}

/**
 * Consulta ao Banco atraves de parametros para obter as Saidas do movimento de ESTOQUE (EST_NOTA_FISCAL e FAT_PEDIDO)  
 * baseados nos filtros [dataIni, dataFim , centroCusto, CodProduto e grupo de Produto]
 * @name movimento_estoque_saida
 * @return ARRAY com [IDPedido, CodProduto, DESCRICAO, SAIDA, TOTAL_SAIDA, DATA_SAIDA ]  
 */
public function movimento_estoque_saida(){
    $grupo   = explode("|", $this->m_grupo);
    $dataIni = c_date::convertDateTxt($this->m_par[0]);
    $dataFim = c_date::convertDateTxt($this->m_par[1]);

    $sql =  "SELECT P.PEDIDO, PI.ITEMESTOQUE AS CODPRODUTO ,PI.DESCRICAO, PI.QTSOLICITADA AS SAIDA, P.TOTAL AS TOTAL_SAIDA, P.EMISSAO AS DATA_SAIDA ";
    $sql .= "FROM FAT_PEDIDO_ITEM PI ";
    $sql .= "LEFT JOIN FAT_PEDIDO P ON (P.ID = PI.ID) ";
    $sql .= "LEFT JOIN EST_PRODUTO PROD ON (PI.ITEMESTOQUE = PROD.CODIGO) ";

    $cond =  strpos($sql, 'where') === false ? 'where' : 'and';
    $sql .=  empty($dataIni) ? '':" $cond (P.EMISSAO BETWEEN '".$dataIni."' AND '".$dataFim."') ";

    $cond =  strpos($sql, 'where') === false ? 'where' : 'and';
    $sql .= empty($this->m_par[3]) ? '':" $cond (PROD.CODIGO = '".$this->m_par[3]."') ";

    $cond = strpos($sql, 'where') === false ? 'where' : 'and';
    $sql .= empty($this->m_par[6]) ? '':" $cond (P.CCUSTO = '".$this->m_par[6]."') ";

    $grupos = '';
    for($i = 1; $i < count($grupo); $i++){
        $grupos .= "'".$grupo[$i]."',";
    }
    $grupos = strstr($grupos, ',', true);
    $cond =  strpos($sql, 'where') === false ? 'where' : 'and';
    $sql .= empty($grupos) ? '':" $cond (PROD.GRUPO IN (".$grupos.")) ";
    
    $sql .= "ORDER BY PI.ITEMESTOQUE ";
    $banco = new c_banco();
    $banco->exec_sql($sql);
    $banco->close_connection();

    $pedSaida = $banco->resultado;

    // NOTA FISCAL SAIDA 

    $sql =  "SELECT NFP.IDNF AS PEDIDO, NFP.CODPRODUTO, NFP.DESCRICAO, NFP.QUANT AS SAIDA, NFP.TOTAL AS TOTAL_SAIDA, NF.DATASAIDAENTRADA AS DATA_SAIDA ";
    $sql .= "FROM EST_NOTA_FISCAL_PRODUTO NFP ";
    $sql .= "LEFT JOIN EST_NOTA_FISCAL NF ON (NFP.IDNF = NF.ID) ";
    $sql .= "LEFT JOIN EST_PRODUTO PROD ON (NFP.CODPRODUTO = PROD.CODIGO) ";
    $sql .= "where NF.TIPO = '1' ";

    $cond =  strpos($sql, 'where') === false ? 'where' : 'and';
    $sql .=  empty($dataIni) ? '':" $cond (NF.DATASAIDAENTRADA BETWEEN '".$dataIni."' AND '".$dataFim."') ";

    $cond =  strpos($sql, 'where') === false ? 'where' : 'and';
    $sql .= empty($this->m_par[3]) ? '':" $cond (PROD.CODIGO = '".$this->m_par[3]."') ";

    $cond = strpos($sql, 'where') === false ? 'where' : 'and';
    $sql .= empty($this->m_par[6]) ? '':" $cond (NF.CENTROCUSTO = '".$this->m_par[6]."') ";

    $grupos = '';
    for($i = 1; $i < count($grupo); $i++){
        $grupos .= "'".$grupo[$i]."',";
    }
    $grupos = strstr($grupos, ',', true);
    $cond =  strpos($sql, 'where') === false ? 'where' : 'and';
    $sql .= empty($grupos) ? '':" $cond (PROD.GRUPO IN (".$grupos.")) ";

    $sql .= "ORDER BY NF.DATASAIDAENTRADA ";
    $banco = new c_banco();
    $banco->exec_sql($sql);
    $banco->close_connection();
    $nfSaida = $banco->resultado;

    $count = count($pedSaida);
    for($i = 0; $i < count($nfSaida); $i++){
        $pedSaida[$count] = $nfSaida[$i];
        $count++;
    }

    return $pedSaida;
}
/**
 * Consulta ao Banco atraves de parametros para obter as Saidas do movimento de ESTOQUE  
 * baseados nos filtros [dataIni, dataFim , centroCusto, CodProduto e grupo de Produto]
 * @name movimento_estoque_saida
 * @return ARRAY com [IDPedido, CodProduto, DESCRICAO, SAIDA, TOTAL_SAIDA, DATA_SAIDA ]  
 */
public function select_relatorio_compras(){
    
    $grupo   = explode("|", $this->m_grupo);
	$sql  = "SELECT DISTINCT P.*, G.DESCRICAO AS NOMEGRUPO, 0 as ESTOQUE, 0 as RESERVA ";
   	$sql .= "FROM EST_PRODUTO P left JOIN EST_GRUPO G ON (G.GRUPO=P.GRUPO) ";
    $sql .= "left JOIN EST_PRODUTO_EQUIVALENCIA E ON (E.IDPRODUTO=P.CODIGO) ";
       
    if ($this->m_par[3] != null) {
        $cond =  strpos($sql, 'where') === false ? 'where' : 'and';
        $sql .= empty($this->m_par[3]) ? '':" $cond (P.CODIGO = '".$this->m_par[3]."')";
    }else{

        $grupos = '';
        for($i = 1; $i < count($grupo); $i++){
            $grupos .= "'".$grupo[$i]."',";
        }
        $grupos = strstr($grupos, ',', true);
        $cond =  strpos($sql, 'where') === false ? 'where' : 'and';
        $sql .= empty($grupos) ? '':" $cond (P.GRUPO IN (".$grupos.")) ";

    }
   	$sql .= "ORDER BY p.descricao ";
        //echo strtoupper($sql)."<br>";
	$banco = new c_banco;
	$banco->exec_sql($sql);
	$banco->close_connection();
	return $banco->resultado;
}// fim select_PRODUTO_letra

/**
 * Consulta ao Banco atraves de parametros para obter as Saidas do movimento de ESTOQUE  
 * baseados nos filtros [dataIni, dataFim , centroCusto, CodProduto e grupo de Produto]
 * @name movimento_estoque_saida
 * @return ARRAY com [IDPedido, CodProduto, DESCRICAO, SAIDA, TOTAL_SAIDA, DATA_SAIDA ]  
 */
public function select_relatorio_compras_sugestoes(){
    
    $dataIni = c_date::convertDateTxt($this->m_par[0]);
    $dataFim = c_date::convertDateTxt($this->m_par[1]);
    $grupo   = explode("|", $this->m_grupo);
    $sql  = "SELECT I.ITEMESTOQUE, P.DESCRICAO, G.DESCRICAO AS NOMEGRUPO, P.CODFABRICANTE, P.QUANTMINIMA, P.QUANTMAXIMA,  P.VENDA, 0 as ESTOQUE, 0 as RESERVA, ";
    $sql .= "SUM(I.QTSOLICITADA) AS QUANT, ";
    $sql .= "SUM(I.TOTAL) AS VALOR, ";
    $sql .= "COUNT(I.ID) AS NUMVENDAS ";
   	$sql .= "FROM FAT_PEDIDO_ITEM I ";
    $sql .= "JOIN EST_PRODUTO P ON P.CODIGO = I.ITEMESTOQUE ";
    $sql .= "JOIN EST_GRUPO G ON P.GRUPO = G.GRUPO ";
    $sql .= "JOIN FAT_PEDIDO PED ON (PED.ID = I.ID) ";
       
    if ($this->m_par[3] != null) {
        $cond =  strpos($sql, 'where') === false ? 'where' : 'and';
        $sql .= empty($this->m_par[3]) ? '':" $cond (P.CODIGO = '".$this->m_par[3]."')";
    }else{

        $grupos = '';
        for($i = 1; $i < count($grupo); $i++){
            $grupos .= "'".$grupo[$i]."',";
        }
        $grupos = strstr($grupos, ',', true);
        $cond =  strpos($sql, 'where') === false ? 'where' : 'and';
        $sql .= empty($grupos) ? '':" $cond (P.GRUPO IN (".$grupos.")) ";

    }

    $cond =  strpos($sql, 'where') === false ? 'where' : 'and';
    $sql .=  empty($dataIni) ? '':" $cond (PED.EMISSAO BETWEEN '".$dataIni."' AND '".$dataFim."') ";
   	$sql .= "GROUP BY I.ITEMESTOQUE 
             ORDER BY NUMVENDAS DESC ";
        //echo strtoupper($sql)."<br>";
	$banco = new c_banco;
	$banco->exec_sql($sql);
	$banco->close_connection();
	return $banco->resultado;
}// fim select_PRODUTO_letra

}	//	END OF THE CLASS
?>
