<?php

/**
 * @package   astec
 * @name      c_nota_fiscal_produto
 * @version   3.0.00
 * @copyright 2016
 * @link      http://www.admservice.com.br/
 * @author    Lucas tortola da Silva Bucko<lucas.tortola@admservice.com.br>
 * @date      12/04/2016
 */
$dir = dirname(__FILE__);
include_once($dir . "/../../bib/c_user.php");
include_once($dir . "/../../bib/c_date.php");
include_once($dir . "/../../bib/c_tools.php");

//Class C_NOTA_FISCAL
Class c_nota_fiscal_produto extends c_user {

/**
 * TABLE NAME EST_NOTA_FISCAL_PRODUTO
 */
    
// Campos tabela - Objetos que existe na classe
    private $id                 = NULL; // integer not null
    private $idNf               = NULL; // integer not null
    private $codProduto         = NULL; // integer not null
    private $itemFabricante     = NULL; // char(25)  null --------------
    private $descricao          = NULL; // char(60) not null
    private $unidade            = NULL; // char(3) not null
    private $quant              = NULL; // numeric(9,4) not null
    private $unitario           = NULL; // numeric(14,6) not null
    private $desconto           = NULL; // numeric(14,6)
    private $total              = NULL; // numeric(12,2) not null
    private $origem             = NULL; // char(1) not null
    private $tribIcms           = NULL; // char (2) not null

    // ICMS e ICMS-ST
    private $ncm                = NULL; // char(15)
    private $cest               = NULL; // char(15) ++++++++++
    private $cfop               = NULL; // INTEGER
    private $aliqIcms           = NULL; // numeric(5,2)
    private $percReducaoBc      = NULL; // numeric(5,2) +++++++
    private $bcIcms             = NULL; // numeric(11,2)
    private $valorIcms          = NULL; // numeric(11,2)
    private $insideIpiBc        = NULL; // char(1)
    private $valorIpi           = NULL; // numeric(11,2)
    private $aliqIpi            = NULL; // numeric(5,2)
    private $percDiferido       = NULL; // numeric(5,2) +++++++
    private $valorIcmsDiferido  = NULL; // numeric(11,2) +++++++
    private $valorIcmsOperacao  = NULL; // numeric(11,2) +++++++
    private $modBcSt            = NULL; // numeric(5,2) +++++++
    private $percMvaSt          = NULL; // numeric(5,2) +++++++
    private $bcFcpSt            = NULL; // numeric(5,2) +++++++    
    private $aliqFcpSt          = NULL; // numeric(5,2) +++++++    
    private $valorFcpSt         = NULL; // numeric(5,2) +++++++        
    private $percReducaoBcSt    = NULL; // numeric(5,2) +++++++
    private $valorBcSt          = NULL; // numeric(11,2) +++++++
    private $AliqIcmsSt         = NULL; // numeric(5,2) +++++++
    private $valorTotalTributos = NULL; // numeric(11,2) +++++++
    private $valorBcStRetido    = NULL; // numeric(11,2) +++++++
    private $valorIcmsStRetido  = NULL; // numeric(11,2) +++++++
    private $vBCSTRet           = NULL; // numeric(11,2)
    private $pST                = NULL; // numeric(5,2)
    private $vICMSSubstituto    = NULL; // numeric(11,2)
    private $vICMSSTRet         = NULL; // numeric(11,2)

    private $custoProduto       = NULL; // numeric(5,2)
    private $nrSerie            = NULL; // char(25)
    private $lote               = NULL; // varchar(15)
    private $dataFabricacao     = NULL; // varchar(4)
    private $dataValidade       = NULL; // varchar(4)
    private $dataGarantia       = NULL; // date
    private $ordem              = NULL; // integer not null
    private $projeto            = NULL; // varchar(20) not null
    private $dataConferencia    = NULL; // timestamp
    private $localizacao        = NULL; // varchar -------------
    private $numSerie           = NULL; // varchar -------------

    //PIS/COFINS
    private $cstPis             = NULL; // varchar -------------
    private $valorBcPis         = NULL; // varchar -------------
    private $aliqPis            = NULL; // varchar -------------
    private $valorPis           = NULL; // varchar -------------
    private $quantBcProdPis     = NULL; // varchar -------------
    private $valorAliqPis       = NULL; // varchar -------------
    private $cstCofins             = NULL; // varchar -------------
    private $valorBcCofins         = NULL; // varchar -------------
    private $aliqCofins            = NULL; // varchar -------------
    private $valorCofins           = NULL; // varchar -------------
    private $quantBcProdCofins     = NULL; // varchar -------------
    private $valorAliqCofins       = NULL; // varchar -------------
    private $cbenef                = NULL; // varchar -------------

    
    //DIFAL
    private $bcFcpUfDest        = NULL; // <vBCFCPUFDest> - Valor da BC FCP na UF de destino
    private $aliqFcpUfDest      = NULL; // <pFCPUFDest> - Percentual do ICMS relativo FCP na UF de destino 
    private $valorFcpUfDest     = NULL; // <vFCPUFDest> - Valor do FCP    
    
    private $bcIcmsUfDest       = NULL; // <vBCUFDest> - Valor da BC do ICMS na UF destino
    private $aliqIcmsUfDest     = NULL; // <pICMSUFDest> - Alíquota interna da UF de destino
    private $aliqIcmsInter      = NULL; // <pICMSInter> - Aliquota de ICMS interestadual
    private $aliqIcmsInterPart  = NULL; // <pICMSInterPart> Percentual provisório de partilha do ICMS Interestadual
    private $valorIcmsUfDest    = NULL; // <vICMSUFDest> Cálculo Difal  BC * (18-12=6)
    private $valorIcmsUFRemet   = NULL; // <vICMSUFRemet> Valor do ICMS Interestadual para a UF do remetente
    
    function __construct(){
        // Cria uma instancia variaveis de sessao
        //session_start();
        c_user::from_array($_SESSION['user_array']);

    }
    /**
    * METODOS DE SETS E GETS
    */


    public function setId($id) { $this->id = $id; }
    public function getId() { return $this->id; }

    public function setIdNf($id) { $this->idNf = $id; }
    public function getIdNf() { return $this->idNf; }

    public function setCodProduto($codProduto) { $this->codProduto = $codProduto; }
    public function getCodProduto() { return $this->codProduto; }

    public function setDescricao($descricao) { $this->descricao = strtoupper($descricao);  }
    public function getDescricao() { return $this->descricao; }

    public function setUnidade($unidade) { $this->unidade = strtoupper($unidade); }
    public function getUnidade() { return $this->unidade; }

    public function setQuant($quant, $format=false) { 
        $this->quant = $quant; 
        if ($format):
           $this->quant = number_format($this->quant, 4, ',', '.');
        endif;
    }
    public function getQuant($format = null) {
        switch ($format) {
            case 'F':
                return number_format($this->quant, 4, ',', '.');
                break;
            case 'B':
                if ($this->quant != null) {
                    $num = str_replace('.', '', $this->quant);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->quant;
        }
    }

    public function setUnitario($unitario, $format=false) { 
        $this->unitario = $unitario; 
        if ($format):
                $this->unitario = number_format($this->unitario, 4, ',', '.');
        endif;
        
    }
    public function getUnitario($format = null) {
        switch ($format) {
            case 'F':
                return number_format((double) $this->unitario, 4, ',', '.');
                break;
            case 'B':
                if ($this->unitario != null) {
                    $num = str_replace('.', '', $this->unitario);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->unitario;
        }
    }

    public function setDesconto($desconto, $format = false) { 
        $this->desconto = strtoupper($desconto); 
        if ($format):
                $this->desconto=number_format($this->desconto, 2, ',', '.');
        endif;
        
    }
    public function getDesconto($format = null) {
        switch ($format) {
            case 'F':
                return number_format((double) $this->desconto, 2, ',', '.');
                break;
            case 'B':
                if ($this->desconto != null) {
                    $num = str_replace('.', '', $this->desconto);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->desconto;
        }
    }

    public function setTotal($total, $format=false) { 
        $this->total = $total; 
        if ($format):
                $this->total = number_format($this->total, 2, ',', '.');
        endif;
        
    }
    public function getTotal($format = null) {
        switch ($format) {
            case 'F':
                return number_format((double) $this->total, 2, ',', '.');
                break;
            case 'B':
                if ($this->total != null) {
                    $num = str_replace('.', '', $this->total);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->total;
        }
    }

    public function setOrigem($origem) { $this->origem = strtoupper($origem); }
    public function getOrigem() { return $this->origem; }

    public function setTribIcms($tribIcms) { $this->tribIcms = strtoupper($tribIcms); }
    public function getTribIcms() { return $this->tribIcms; }

    public function setNcm($ncm) { $this->ncm = strtoupper($ncm); }
    public function getNcm($format = null) { return $this->ncm;  }

    public function setCest($cest) { $this->cest = strtoupper($cest); }
    public function getCest() { return $this->cest;  }

    public function setCfop($cfop) { $this->cfop = $cfop; }
    public function getCfop() { return $this->cfop; }

    public function setModBc($modBc) { $this->modBc = strtoupper($modBc); }
    public function getModBc() { return $this->modBc; }

    public function setAliqIcms($aliqIcms, $format=false) { 
        $this->aliqIcms = $aliqIcms; 
        if ($format):
                $this->aliqIcms = number_format($this->aliqIcms, 2, ',', '.');
            
        endif;
        
    }
    public function getAliqIcms($format = null) {
        switch ($format) {
            case 'F':
                return number_format((double) $this->aliqIcms, 2, ',', '.');
                break;
            case 'B':
                if ($this->aliqIcms != null) {
                    $num = str_replace('.', '', $this->aliqIcms);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->aliqIcms;
        }
    }

    public function setPercReducaoBc($percReducaoBc, $format=false) { 
        $this->percReducaoBc = $percReducaoBc; 
        if ($format):
                $this->percReducaoBc = number_format($this->percReducaoBc, 2, ',', '.');
            
        endif;
        
    }
    public function getPercReducaoBc($format = null) {
        switch ($format) {
            case 'F':
                return number_format($this->percReducaoBc, 2, ',', '.');
                break;
            case 'B':
                if ($this->percReducaoBc != null) {
                    $num = str_replace('.', '', $this->percReducaoBc);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->percReducaoBc;
        }
    }

    public function setBcIcms($bcIcms, $format=false) { 
        $this->bcIcms = $bcIcms; 
        if ($format):
                $this->bcIcms = number_format($this->bcIcms, 2, ',', '.');
            
        endif;
        
    }
    public function getBcIcms($format = null) {
        switch ($format) {
            case 'F':
                return number_format((double) $this->bcIcms, 2, ',', '.');
                break;
            case 'B':
                if ($this->bcIcms != null) {
                    $num = str_replace('.', '', $this->bcIcms);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->bcIcms;
        }
    }

    public function setValorIcms($valorIcms, $format=false) { 
        $this->valorIcms = $valorIcms; 
        if ($format):
                $this->valorIcms = number_format($this->valorIcms, 2, ',', '.');
            
        endif;
        
    }
    public function getValorIcms($format = null) {
        switch ($format) {
            case 'F':
                return number_format((double) $this->valorIcms, 2, ',', '.');
                break;
            case 'B':
                if ($this->valorIcms != null) {
                    $num = str_replace('.', '', $this->valorIcms);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->valorIcms;
        }
    }

    public function setInsideIpiBc($insideIpiBc){$this->insideIpiBc = strtoupper($insideIpiBc);}
    public function getInsideIpiBc(){return $this->insideIpiBc;}
    
    public function setValorIpi($valorIpi, $format=false) { 
        $this->valorIpi = $valorIpi; 
        if ($format):
                $this->valorIpi = number_format($this->valorIpi, 2, ',', '.');
            
        endif;
        
    }
    public function getValorIpi($format = null) {
        switch ($format) {
            case 'F':
                return number_format((double) $this->valorIpi, 2, ',', '.');
                break;
            case 'B':
                if ($this->valorIpi != null) {
                    $num = str_replace('.', '', $this->valorIpi);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->valorIpi;
        }
    }

    public function setAliqIpi($aliqIpi, $format=false) { 
        $this->AliqIpi = $aliqIpi; 
        if ($format):
                $this->AliqIpi = number_format($this->aliqIpi, 2, ',', '.');
            
        endif;
        
    }
    public function getAliqIpi($format = null) {
        switch ($format) {
            case 'F':
                return number_format((double) $this->aliqIpi, 2, ',', '.');
                break;
            case 'B':
                if ($this->aliqIpi != null) {
                    $num = str_replace('.', '', $this->aliqIpi);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->aliqIpi;
        }
    }

    public function setPercDiferido($percDiferido, $format=false) { 
        $this->percDiferido = $percDiferido; 
        if ($format):
                $this->percDiferido = number_format($this->percDiferido, 2, ',', '.');
        endif;
        
    }
    public function getPercDiferido($format = null) {
        switch ($format) {
            case 'F':
                return number_format($this->percDiferido, 2, ',', '.');
                break;
            case 'B':
                if ($this->percDiferido != null) {
                    $num = str_replace('.', '', $this->percDiferido);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->percDiferido;
        }
    }

    public function setValorIcmsDiferido($valorIcmsDiferido , $format=false) { 
        $this->valorIcmsDiferido = $valorIcmsDiferido; 
        if ($format):
                $this->valorIcmsDiferido = number_format($this->valorIcmsDiferido, 2, ',', '.');
        endif;
        
    }
    public function getValorIcmsDiferido($format = null) {
        switch ($format) {
            case 'F':
                return number_format($this->valorIcmsDiferido, 2, ',', '.');
                break;
            case 'B':
                if ($this->valorIcmsDiferido != null) {
                    $num = str_replace('.', '', $this->valorIcmsDiferido);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->valorIcmsDiferido;
        }
    }
    
    public function setValorIcmsOperacao($valorIcmsOperacao, $format=false) { 
        $this->valorIcmsOperacao = $valorIcmsOperacao; 
        if ($format):
                $this->valorIcmsOperacao = number_format($this->valorIcmsOperacao, 2, ',', '.');
        endif;
        
    }
    public function getValorIcmsOperacao($format = null) {
        switch ($format) {
            case 'F':
                return number_format($this->valorIcmsOperacao, 2, ',', '.');
                break;
            case 'B':
                if ($this->valorIcmsOperacao != null) {
                    $num = str_replace('.', '', $this->valorIcmsOperacao);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->valorIcmsOperacao;
        }
    }
    
    public function setModBcSt($modBcSt) { $this->modBcSt = strtoupper($modBcSt); }
    public function getModBcSt() { return $this->modBcSt; }

    public function setPercMvaSt($percMvaSt, $format=false) { 
        $this->percMvaSt = $percMvaSt; 
        if ($format):
                $this->percMvaSt = number_format($this->percMvaSt, 4, ',', '.');
        endif;        
    }
    public function getPercMvaSt($format = null) {
        switch ($format) {
            case 'F':
                return number_format($this->percMvaSt, 4, ',', '.');
                break;
            case 'B':
                if ($this->percMvaSt != null) {
                    $num = str_replace('.', '', $this->percMvaSt);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->percMvaSt;
        }
    }

    public function setBcFcpSt($bcFcpSt, $format=false) { 
        $this->bcFcpSt = $bcFcpSt; 
        if ($format):
                $this->bcFcpSt = number_format($this->bcFcpSt, 4, ',', '.');
        endif;        
    }
    public function getBcFcpSt($format = null) {
        switch ($format) {
            case 'F':
                return number_format($this->bcFcpSt, 4, ',', '.');
                break;
            case 'B':
                if ($this->bcFcpSt != null) {
                    $num = str_replace('.', '', $this->bcFcpSt);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->bcFcpSt;
        }
    }   
    
    public function setAliqFcpSt($aliqFcpSt, $format=false) { 
        $this->aliqFcpSt = $aliqFcpSt; 
        if ($format):
                $this->aliqFcpSt = number_format($this->aliqFcpSt, 4, ',', '.');
        endif;        
    }
    public function getAliqFcpSt($format = null) {
        switch ($format) {
            case 'F':
                return number_format($this->aliqFcpSt, 4, ',', '.');
                break;
            case 'B':
                if ($this->aliqFcpSt != null) {
                    $num = str_replace('.', '', $this->aliqFcpSt);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->aliqFcpSt;
        }
    } 
    
    public function setValorFcpSt($valorFcpSt, $format=false) { 
        $this->valorFcpSt = $valorFcpSt; 
        if ($format):
                $this->valorFcpSt = number_format($this->valorFcpSt, 4, ',', '.');
        endif;        
    }
    public function getValorFcpSt($format = null) {
        switch ($format) {
            case 'F':
                return number_format($this->valorFcpSt, 4, ',', '.');
                break;
            case 'B':
                if ($this->valorFcpSt != null) {
                    $num = str_replace('.', '', $this->valorFcpSt);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->valorFcpSt;
        }
    }     
    
    public function setPercReducaoBcSt($percReducaoBcSt, $format=false) { 
        $this->percReducaoBcSt = $percReducaoBcSt; 
        if ($format):
                $this->percReducaoBcSt = number_format($this->percReducaoBcSt, 2, ',', '.');
        endif;
        
    }
    public function getPercReducaoBcSt($format = null) {
        switch ($format) {
            case 'F':
                return number_format($this->percReducaoBcSt, 2, ',', '.');
                break;
            case 'B':
                if ($this->percReducaoBcSt != null) {
                    $num = str_replace('.', '', $this->percReducaoBcSt);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->percReducaoBcSt;
        }
    }

    public function setValorBcSt($valorBcSt, $format=false) { 
        $this->valorBcSt = $valorBcSt; 
        if ($format):
                $this->valorBcSt = number_format($this->valorBcSt, 2, ',', '.');
        endif;
        
    }
    public function getValorBcSt($format = null) {
        switch ($format) {
            case 'F':
                return number_format($this->valorBcSt, 2, ',', '.');
                break;
            case 'B':
                if ($this->valorBcSt != null) {
                    $num = str_replace('.', '', $this->valorBcSt);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->valorBcSt;
        }
    }

    public function setAliqIcmsSt($aliqIcmsSt, $format=false) { 
        $this->aliqIcmsSt = $aliqIcmsSt; 
        if ($format):
                $this->aliqIcmsSt = number_format($this->aliqIcmsSt, 2, ',', '.');
        endif;
        
    }
    public function getAliqIcmsSt($format = null) {
        switch ($format) {
            case 'F':
                return number_format($this->aliqIcmsSt, 2, ',', '.');
                break;
            case 'B':
                if ($this->aliqIcmsSt != null) {
                    $num = str_replace('.', '', $this->aliqIcmsSt);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->aliqIcmsSt;
        }
    }

    public function setValorIcmsSt($valorIcmsSt, $format=false) { 
        $this->valorIcmsSt = $valorIcmsSt; 
        if ($format):
                $this->valorIcmsSt = number_format($this->valorIcmsSt, 2, ',', '.');
        endif;
        
    }
    public function getValorIcmsSt($format = null) {
        switch ($format) {
            case 'F':
                return number_format($this->valorIcmsSt, 2, ',', '.');
                break;
            case 'B':
                if ($this->valorIcmsSt != null) {
                    $num = str_replace('.', '', $this->valorIcmsSt);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->valorIcmsSt;
        }
    }
    
    public function setValorTotalTributos($valorTotalTributos, $format=false) {  
        $this->valorTotalTributos = $valorTotalTributos; 
        if ($format):
            $this->valorTotalTributos = number_format($this->valorTotalTributos, 2, ',', '.');
        endif;
        
    }
    public function getValorTotalTributos($format = null) {
        if ($format == 'F') {
            return number_format($this->valorTotalTributos, 2, ',', '.');
        } else {
            if ($this->valorTotalTributos != null) {
                $num = str_replace('.', '', $this->valorTotalTributos);
                $num = str_replace(',', '.', $num);
                return $num;
            } else {
                return 0;
            }
        }
    }

    public function setVBCSTRet($vBCSTRet, $format=false) {  
        $this->vBCSTRet = $vBCSTRet; 
        if ($format):
            $this->vBcStRet = number_format($this->vBCSTRet, 2, ',', '.');
        endif;
        
    }
    public function getVBCSTRet($format = null) {
        if ($format == 'F') {
            return number_format($this->vBCSTRet, 2, ',', '.');
        } else {
            if ($this->vBCSTRet != null) {
                $num = str_replace('.', '', $this->vBCSTRet);
                $num = str_replace(',', '.', $num);
                return $num;
            } else {
                return 0;
            }
        }
    }

    public function setPSt($pST, $format=false) { 
        $this->pST = $pST; 
        if ($format):
                $this->aliqIcms = number_format($this->pST, 2, ',', '.');
        endif;        
    }

    public function getPSt($format = null) {
        switch ($format) {
            case 'F':
                return number_format((double) $this->pST, 2, ',', '.');
                break;
            case 'B':
                if ($this->pST != null) {
                    $num = str_replace('.', '', $this->pST);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->pST;
        }
    }

    public function setVICMSSubstituto($vICMSSubstituto, $format=false) {  
        $this->vICMSSubstituto = $vICMSSubstituto; 
        if ($format):
            $this->vICMSSubstituto = number_format($this->vICMSSubstituto, 2, ',', '.');
        endif;        
    }
    
    public function getVICMSSubstituto($format = null) {
        if ($format == 'F') {
            return number_format($this->vICMSSubstituto, 2, ',', '.');
        } else {
            if ($this->vICMSSubstituto != null) {
                $num = str_replace('.', '', $this->vICMSSubstituto);
                $num = str_replace(',', '.', $num);
                return $num;
            } else {
                return 0;
            }
        }
    }

    public function setVICMSSTRet($vICMSSTRet, $format=false) {  
        $this->vICMSSTRet = $vICMSSTRet; 
        if ($format):
            $this->vICMSSTRet = number_format($this->vICMSSTRet, 2, ',', '.');
        endif;
        
    }
    public function getVICMSSTRet($format = null) {
        if ($format == 'F') {
            return number_format($this->vICMSSTRet, 2, ',', '.');
        } else {
            if ($this->vICMSSTRet != null) {
                $num = str_replace('.', '', $this->vICMSSTRet);
                $num = str_replace(',', '.', $num);
                return $num;
            } else {
                return 0;
            }
        }
    }

    public function setCustoProduto($custoProduto, $format=false) {  
        $this->custoProduto = $custoProduto; 
        if ($format):
            $this->custoProduto = number_format($this->custoProduto, 2, ',', '.');
        endif;
        
    }
    public function getCustoProduto($format = null) {
        if ($format == 'F') {
            return number_format($this->custoProduto, 2, ',', '.');
        } else {
            if ($this->custoProduto != null) {
                $num = str_replace('.', '', $this->custoProduto);
                $num = str_replace(',', '.', $num);
                return $num;
            } else {
                return 0;
            }
        }
    }

    public function setNrSerie($NrSerie) { $this->NrSerie = strtoupper($NrSerie); }
    public function getNrSerie() { return $this->NrSerie; }

    public function setLote($lote) { $this->lote = strtoupper($lote); }
    public function getLote() { return strtoupper($this->lote); }

    public function setDataFabricacao($dataFabricacao) { $this->dataFabricacao = strtoupper($dataFabricacao); }
    public function getDataFabricacao($format = null) { 
         if (($this->dataFabricacao != '') && ($this->dataFabricacao != '0000-00-00 00:00:00')) {
            $this->dataFabricacao = strtr($this->dataFabricacao, "/", "-");
            switch ($format) {
                case 'F':
                    return date('d/m/Y H:i:s', strtotime($this->dataFabricacao));
                    break;
                case 'B':
                    return c_date::convertDateBd($this->dataFabricacao, $this->m_banco);
                    break;
                default:
                    return $this->dataFabricacao;
            }
        } else
            return '';
        
    }

    public function setDataValidade($dataValidade) { $this->dataValidade = strtoupper($dataValidade); }

    public function getDataValidade($format = null) { 
         if (($this->dataValidade != '') && ($this->dataValidade != '0000-00-00 00:00:00')) {
            $this->dataValidade = strtr($this->dataValidade, "/", "-");
            switch ($format) {
                case 'F':
                    return date('d/m/Y H:i:s', strtotime($this->dataValidade));
                    break;
                case 'B':
                    return c_date::convertDateBd($this->dataValidade, $this->m_banco);
                    break;
                default:
                    return $this->dataValidade;
            }
        } else
            return '';
        
    }

    public function setDataGarantia($dataGarantia) { $this->dataGarantia = strtoupper($dataGarantia); }
    public function getDataGarantia($format = null) {
         if (($this->dataGarantia != '') && ($this->dataGarantia != '0000-00-00 00:00:00')) {
            $this->dataGarantia = strtr($this->dataGarantia, "/", "-");
            switch ($format) {
                case 'F':
                    return date('d/m/Y H:i:s', strtotime($this->dataGarantia));
                    break;
                case 'B':
                    return c_date::convertDateBd($this->dataGarantia, $this->m_banco);
                    break;
                default:
                    return $this->dataGarantia;
            }
        } else
            return '';
    }

    public function setOrdem($ordem) { $this->ordem = $ordem; }
    public function getOrdem() { return $this->ordem; }

    public function setProjeto($projeto) { $this->projeto = $projeto; }
    public function getProjeto() { return $this->projeto; }

    public function setDataConferencia($dataConferencia) { $this->dataConferencia = $dataConferencia; }
    public function getDataConferencia($format = NULL) {
        if (($this->dataConferencia != '') && ($this->dataConferencia != '0000-00-00 00:00:00')) {
            $this->dataConferencia = strtr($this->dataConferencia, "/", "-");
            switch ($format) {
                case 'F':
                    return date('d/m/Y H:i:s', strtotime($this->dataConferencia));
                    break;
                case 'B':
                    return c_date::convertDateBd($this->dataConferencia, $this->m_banco);
                    break;
                default:
                    return $this->dataConferencia;
            }
        } else
            return '';
    }

    public function setCstPis($cstPis) { 
        $this->cstPis = $cstPis; 
        
    }
    public function getCstPis($format = null) {
                return $this->cstPis;
    }

    public function setBcPis($valorBcPis, $format=false) { 
        $this->valorBcPis = $valorBcPis; 
        if ($format):
                $this->valorBcPis = number_format($this->valorBcPis, 2, ',', '.');
            
        endif;
        
    }
    public function getBcPis($format = null) {
        switch ($format) {
            case 'F':
                return number_format((double) $this->valorBcPis, 2, ',', '.');
                break;
            case 'B':
                if ($this->valorBcPis != null) {
                    $num = str_replace('.', '', $this->valorBcPis);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->valorBcPis;
        }
    }

    public function setAliqPis($aliqPis, $format=false) { 
        $this->aliqPis = $aliqPis; 
        if ($format):
                $this->aliqPis = number_format($this->aliqPis, 2, ',', '.');
            
        endif;
        
    }
    public function getAliqPis($format = null) {
        switch ($format) {
            case 'F':
                return number_format((double) $this->aliqPis, 2, ',', '.');
                break;
            case 'B':
                if ($this->aliqPis != null) {
                    $num = str_replace('.', '', $this->aliqPis);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->aliqPis;
        }
    }
    
    public function setValorPis($valorPis, $format=false) { 
        $this->valorPis = $valorPis; 
        if ($format):
                $this->valorPis = number_format($this->valorPis, 2, ',', '.');
            
        endif;
        
    }
    public function getValorPis($format = null) {
        switch ($format) {
            case 'F':
                return number_format((double) $this->valorPis, 2, ',', '.');
                break;
            case 'B':
                if ($this->valorPis != null) {
                    $num = str_replace('.', '', $this->valorPis);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->valorPis;
        }
    }
    
    public function setQuantBcProdPis($quantBcProdPis, $format=false) { 
        $this->quantBcProdPis = $quantBcProdPis; 
        if ($format):
                $this->quantBcProdPis = number_format($this->quantBcProdPis, 2, ',', '.');
            
        endif;
        
    }
    public function getQuantBcProdPis($format = null) {
        switch ($format) {
            case 'F':
                return number_format((double) $this->quantBcProdPis, 2, ',', '.');
                break;
            case 'B':
                if ($this->quantBcProdPis != null) {
                    $num = str_replace('.', '', $this->quantBcProdPis);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->quantBcProdPis;
        }
    }

    public function setCstCofins($cstCofins) { 
        $this->cstCofins = $cstCofins; 
        
    }
    public function getCstCofins($format = null) {
                return $this->cstCofins;
    }

    public function setBcCofins($valorBcCofins, $format=false) { 
        $this->valorBcCofins = $valorBcCofins; 
        if ($format):
                $this->valorBcCofins = number_format($this->valorBcCofins, 2, ',', '.');
            
        endif;
        
    }
    public function getBcCofins($format = null) {
        switch ($format) {
            case 'F':
                return number_format((double) $this->valorBcCofins, 2, ',', '.');
                break;
            case 'B':
                if ($this->valorBcCofins != null) {
                    $num = str_replace('.', '', $this->valorBcCofins);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->valorBcCofins;
        }
    }

    public function setAliqCofins($aliqCofins, $format=false) { 
        $this->aliqCofins = $aliqCofins; 
        if ($format):
                $this->aliqCofins = number_format($this->aliqCofins, 2, ',', '.');
            
        endif;
        
    }
    public function getAliqCofins($format = null) {
        switch ($format) {
            case 'F':
                return number_format((double) $this->aliqCofins, 2, ',', '.');
                break;
            case 'B':
                if ($this->aliqCofins != null) {
                    $num = str_replace('.', '', $this->aliqCofins);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->aliqCofins;
        }
    }
    
    public function setValorCofins($valorCofins, $format=false) { 
        $this->valorCofins = $valorCofins; 
        if ($format):
                $this->valorCofins = number_format($this->valorCofins, 2, ',', '.');
            
        endif;
        
    }
    public function getValorCofins($format = null) {
        switch ($format) {
            case 'F':
                return number_format((double) $this->valorCofins, 2, ',', '.');
                break;
            case 'B':
                if ($this->valorCofins != null) {
                    $num = str_replace('.', '', $this->valorCofins);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->valorCofins;
        }
    }
    
    public function setQuantBcProdCofins($quantBcProdCofins, $format=false) { 
        $this->quantBcProdCofins = $quantBcProdCofins; 
        if ($format):
                $this->quantBcProdCofins = number_format($this->quantBcProdCofins, 2, ',', '.');
            
        endif;
        
    }
    public function getQuantBcProdCofins($format = null) {
        switch ($format) {
            case 'F':
                return number_format((double) $this->quantBcProdCofins, 2, ',', '.');
                break;
            case 'B':
                if ($this->quantBcProdCofins != null) {
                    $num = str_replace('.', '', $this->quantBcProdCofins);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->quantBcProdCofins;
        }
    }


    public function setCBenef($cbenef) { $this->cbenef = $cbenef; }
    public function getCBenef() { return $this->cbenef;    }

    // DIFAL
    public function setBcFcpUfDest($bcFcpUfDest, $format=false) { 
        $this->bcFcpUfDest = $bcFcpUfDest; 
        if ($format):
                $this->bcFcpUfDest = number_format($this->bcFcpUfDest, 2, ',', '.');            
        endif;        
    }
    public function getBcFcpUfDest($format = null) {
        switch ($format) {
            case 'F':
                return number_format((double) $this->bcFcpUfDest, 2, ',', '.');
                break;
            case 'B':
                if ($this->bcFcpUfDest != null) {
                    $num = str_replace('.', '', $this->bcFcpUfDest);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->bcFcpUfDest;
        }
    }

    public function setAliqFcpUfDest($aliqFcpUfDest, $format=false) { 
        $this->aliqFcpUfDest = $aliqFcpUfDest; 
        if ($format):
                $this->aliqFcpUfDest = number_format($this->aliqFcpUfDest, 2, ',', '.');            
        endif;        
    }
    public function getAliqFcpUfDest($format = null) {
        switch ($format) {
            case 'F':
                return number_format((double) $this->aliqFcpUfDest, 2, ',', '.');
                break;
            case 'B':
                if ($this->aliqFcpUfDest != null) {
                    $num = str_replace('.', '', $this->aliqFcpUfDest);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->aliqFcpUfDest;
        }
    }

    public function setAliqIcmsInter($aliqIcmsInter, $format=false) { 
        $this->aliqIcmsInter = $aliqIcmsInter; 
        if ($format):
                $this->aliqIcmsInter = number_format($this->aliqIcmsInter, 2, ',', '.');            
        endif;        
    }
    public function getAliqIcmsInter($format = null) {
        switch ($format) {
            case 'F':
                return number_format((double) $this->aliqIcmsInter, 2, ',', '.');
                break;
            case 'B':
                if ($this->aliqIcmsInter != null) {
                    $num = str_replace('.', '', $this->aliqIcmsInter);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->aliqIcmsInter;
        }
    } 

    public function setaliqIcmsInterPart($aliqIcmsInterPart, $format=false) { 
        $this->aliqIcmsInterPart = $aliqIcmsInterPart; 
        if ($format):
                $this->aliqIcmsInterPart = number_format($this->aliqIcmsInterPart, 2, ',', '.');            
        endif;        
    }
    public function getAliqIcmsInterPart($format = null) {
        switch ($format) {
            case 'F':
                return number_format((double) $this->aliqIcmsInterPart, 2, ',', '.');
                break;
            case 'B':
                if ($this->aliqIcmsInterPart != null) {
                    $num = str_replace('.', '', $this->aliqIcmsInterPart);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->aliqIcmsInterPart;
        }
    } 

    public function setValorFcpUfDest($valorFcpUfDest, $format=false) { 
        $this->valorFcpUfDest = $valorFcpUfDest; 
        if ($format):
                $this->valorFcpUfDest = number_format($this->valorFcpUfDest, 2, ',', '.');            
        endif;        
    }
    public function getValorFcpUfDest($format = null) {
        switch ($format) {
            case 'F':
                return number_format((double) $this->valorFcpUfDest, 2, ',', '.');
                break;
            case 'B':
                if ($this->valorFcpUfDest != null) {
                    $num = str_replace('.', '', $this->valorFcpUfDest);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->valorFcpUfDest;
        }
    }    

    public function setBcIcmsUfDest($bcIcmsUfDest, $format=false) { 
        $this->bcIcmsUfDest = $bcIcmsUfDest; 
        if ($format):
                $this->bcIcmsUfDest = number_format($this->bcIcmsUfDest, 2, ',', '.');            
        endif;        
    }
    public function getBcIcmsUfDest($format = null) {
        switch ($format) {
            case 'F':
                return number_format((double) $this->bcIcmsUfDest, 2, ',', '.');
                break;
            case 'B':
                if ($this->bcIcmsUfDest != null) {
                    $num = str_replace('.', '', $this->bcIcmsUfDest);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->bcIcmsUfDest;
        }
    }    

    public function setAliqIcmsUfDest($aliqIcmsUfDest, $format=false) { 
        $this->aliqIcmsUfDest = $aliqIcmsUfDest; 
        if ($format):
                $this->aliqIcmsUfDest = number_format($this->aliqIcmsUfDest, 2, ',', '.');            
        endif;        
    }
    public function getAliqIcmsUfDest($format = null) {
        switch ($format) {
            case 'F':
                return number_format((double) $this->aliqIcmsUfDest, 2, ',', '.');
                break;
            case 'B':
                if ($this->aliqIcmsUfDest != null) {
                    $num = str_replace('.', '', $this->aliqIcmsUfDest);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->aliqIcmsUfDest;
        }
    } 
 
    public function setValorIcmsUFDest($valorIcmsUFDest, $format=false) { 
        $this->valorIcmsUFDest = $valorIcmsUFDest; 
        if ($format):
                $this->valorIcmsUFDest = number_format($this->valorIcmsUFDest, 2, ',', '.');            
        endif;        
    }
    public function getValorIcmsUFDest($format = null) {
        switch ($format) {
            case 'F':
                return number_format((double) $this->valorIcmsUFDest, 2, ',', '.');
                break;
            case 'B':
                if ($this->valorIcmsUFDest != null) {
                    $num = str_replace('.', '', $this->valorIcmsUFDest);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->valorIcmsUFDest;
        }
    } 

    public function setValorIcmsUFRemet($valorIcmsUFRemet, $format=false) { 
        $this->valorIcmsUFRemet = $valorIcmsUFRemet; 
        if ($format):
                $this->valorIcmsUFRemet = number_format($this->valorIcmsUFRemet, 2, ',', '.');            
        endif;        
    }
    public function getValorIcmsUFRemet($format = null) {
        switch ($format) {
            case 'F':
                return number_format((double) $this->valorIcmsUFRemet, 2, ',', '.');
                break;
            case 'B':
                if ($this->valorIcmsUFRemet != null) {
                    $num = str_replace('.', '', $this->valorIcmsUFRemet);
                    $num = str_replace(',', '.', $num);
                    return $num;
                } else {
                    return 0;
                }
                break;
            default:
                return $this->valorIcmsUFRemet;
        }
    } 
    
    //############### FIM SETS E GETS ###############

//---------------------------------------------------------------
//---------------------------------------------------------------
    function setNotaFiscalProduto() {

        $notaFiscal = $this->select_nota_fiscal_produto();
        $this->setId($notaFiscal[0]['ID']);
        $this->setIdNf($notaFiscal[0]['IDNF']);
        $this->setCodProduto($notaFiscal[0]['CODPRODUTO']);
        $this->setDescricao($notaFiscal[0]['DESCRICAO']);
        $this->setUnidade($notaFiscal[0]['UNIDADE']);
        $this->setQuant($notaFiscal[0]['QUANT']);
        $this->setUnitario($notaFiscal[0]['UNITARIO']);
        $this->setDesconto($notaFiscal[0]['DESCONTO']);
        $this->setTotal($notaFiscal[0]['TOTAL']);
        $this->setOrigem($notaFiscal[0]['ORIGEM']);
        $this->setTribIcms($notaFiscal[0]['TRIBICMS']);
        $this->setNcm($notaFiscal[0]['NCM']);
        $this->setCest($notaFiscal[0]['CEST']);
        $this->setCfop($notaFiscal[0]['CFOP']);
        $this->setAliqIcms($notaFiscal[0]['ALIQICMS']);
        $this->setPercReducaoBc($notaFiscal[0]['PERCREDUCAOBC']);
        $this->setModBc($notaFiscal[0]['MODBC']);
        $this->setBcIcms($notaFiscal[0]['BCICMS']);
        $this->setValorIcms($notaFiscal[0]['VALORICMS']);
        $this->setAliqIpi($notaFiscal[0]['ALIQIPI']);
        $this->setValorIpi($notaFiscal[0]['VALORIPI']);
        $this->setPercDiferido($notaFiscal[0]['PERCDIFERIDO']);
        $this->setValorIcmsDiferido($notaFiscal[0]['VALORICMSDIFERIDO']);
        $this->setValorIcmsOperacao($notaFiscal[0]['VALORICMSOPERACAO']);
        $this->setModBcSt($notaFiscal[0]['MODBCST']);
        $this->setPercMvaSt($notaFiscal[0]['PERCMVAST']);
        $this->setBcFcpSt($notaFiscal[0]['BCFCPST']);
        $this->setAliqFcpSt($notaFiscal[0]['ALIQFCPST']);
        $this->setValorFcpSt($notaFiscal[0]['VALORFCPST']);                
        $this->setPercReducaoBcSt($notaFiscal[0]['PERCREDUCAOBCST']);
        $this->setValorBcSt($notaFiscal[0]['VALORBCST']);
        $this->setAliqIcmsSt($notaFiscal[0]['ALIQICMSST']);
        $this->setValorIcmsSt($notaFiscal[0]['VALORICMSST']);
        $this->setValorTotalTributos($notaFiscal[0]['VALORTOTALTRIBUTOS']);
        //$this->setVBCSTRet($notaFiscal[0]['VALORBCSTRETIDO']);
        //$this->setVICMSSTRet($notaFiscal[0]['VALORICMSSTRETIDO']);
        $this->setCustoProduto($notaFiscal[0]['CUSTOPRODUTO']);
        $this->setNrSerie($notaFiscal[0]['NRSERIE']);
        $this->setLote($notaFiscal[0]['LOTE']);
        $this->setDataFabricacao($notaFiscal[0]['DATAFABRICACAO']);
        $this->setDataValidade($notaFiscal[0]['DATAVALIDADE']);
        $this->setDataGarantia($notaFiscal[0]['DATAGARANTIA']);
        $this->setDataConferencia($notaFiscal[0]['DATACONFERENCIA']);
        $this->setOrdem($notaFiscal[0]['ORDEM']);
        $this->setProjeto($notaFiscal[0]['PROJETO']);
        $this->setCstPis($notaFiscal[0]['CSTPIS']);
        $this->setBcPis($notaFiscal[0]['BCPIS']);
        $this->setAliqPis($notaFiscal[0]['ALIQPIS']);
        $this->setValorPis($notaFiscal[0]['VALORPIS']);
        $this->setCstCofins($notaFiscal[0]['CSTCOFINS']);
        $this->setBcCofins($notaFiscal[0]['BCCOFINS']);
        $this->setAliqCofins($notaFiscal[0]['ALIQCOFINS']);        
        $this->setValorCofins($notaFiscal[0]['VALORCOFINS']);
        $this->setVBCSTRet($notaFiscal[0]['VBCSTRET']);
        $this->setPSt($notaFiscal[0]['PST']);
        $this->setVICMSSubstituto($notaFiscal[0]['VICMSSUBSTITUTO']);
        $this->setVICMSSTRet($notaFiscal[0]['VICMSSTRET']);
        $this->setCBenef($notaFiscal[0]['CBENEF']);

        $this->setBcFcpUfDest($notaFiscal[0]['BCFCPUFDEST']);        
        $this->setAliqFcpUfDest($notaFiscal[0]['ALIQFCPUFDEST']); 
        $this->setValorFcpUfDest($notaFiscal[0]['VALORFCPUFDEST']);
        
        $this->setBcIcmsUfDest($notaFiscal[0]['BCICMSUFDEST']);
        $this->setAliqIcmsUfDest($notaFiscal[0]['ALIQICMSUFDEST']);
        $this->setAliqIcmsInter($notaFiscal[0]['ALIQICMSINTER']);
        $this->setAliqIcmsInterPart($notaFiscal[0]['ALIQICMSINTERPART']);       
        $this->setValorIcmsUfDest($notaFiscal[0]['VALORICMSUFDEST']);
        $this->setValorIcmsUfRemet($notaFiscal[0]['VALORICMSUFREMET']);

        
        
    }    
        
    /**
     * <b> É responsavel por calcular o total do produto </b>
     * @name atualizaTotalNfe
     * @param int $idnf
     * @return total - valor total do produto considerando descontos.
     */
    public function atualizaTotalNfe($idnf = NULL){

        $banco = new c_banco();
        $sql = "SELECT sum(total) as tot FROM EST_NOTA_FISCAL_PRODUTO  where (idnf=".$idnf.")";
        $banco->exec_sql($sql);
        $arrTotal =  $banco->resultado;
        if ($arrTotal[0]['TOT'] == null):
            $total = 0;
        else:
            $total = $arrTotal[0]['TOT'];
        endif;
        
        
        $sql = "update EST_NOTA_FISCAL set totalnf = ".$total;
        $sql .= " WHERE (id=" . $idnf . ")";
        // echo strtoupper($sql);

        $banco->exec_sql($sql);
        $banco->close_connection();
        return $banco->result;
        
    }
    

    /**
     * <b> É responsavel por calcular o total do produto </b>
     * @name calculaTotalNfe
     * @param obj $objNfProd
     * @return total - valor total do produto considerando descontos.
     */
    public function calculaTotalProduto($objNfProd = NULL){
        
        $quant = $objNfProd->getQuant('B');
        $vlUnitario = $objNfProd->getUnitario('B');
        $vlDesconto = $objNfProd->getDesconto('B');
        $aliqIpi = $objNfProd->getAliqIpi('B');
        $vlIpi = $objNfProd->getValorIpi('B');
        $vlTotal = 0;
        
        if ($quant == ''):
            $this->setQuant(1);
            $quant = 1;
        endif;

        $vlTotal = ($quant * $vlUnitario) - $vlDesconto;
        
        if ($aliqIpi == ''):
            $this->setAliqIpi(0);
            $this->setValorIpi(0);
            $aliqIpi = 0;
        else:
            $aliqIpi = $vlTotal + (($aliqIpi * $vlTotal) / 100);
        endif;
        return $vlTotal;
    }

    /**
     * <b> É responsavel por buscar informações da tabela tritutos para calculo dos impostos da NFe </b>
     * <b> os campos NCM e CEST são opcionais </b>
     * @name calculaImpostosNfe
     * @param int natOp
     * @param VARCHAR uf
     * @param CHAR tipoPessoa
     * @param VARCHAR origem 
     * @param VARCHAR tribIcms
     * @param VARCHAR ncm
     * @param VARCHAR cest
     * @return vazio - os campos são calculados e setados dentro da função, não havendo retorno.
     */
    public function calculaImpostosNfeOld($objNfProd = NULL, $natOp = NULL, $uf=NULL, $tipoPessoa=NULL, $format=TRUE){

    $arrTributos =  [];
    $origem=$objNfProd->getOrigem();
    $tribIcms=$objNfProd->getTribIcms();
    $ncm=$objNfProd->getNcm();
    $cest=$objNfProd->getCest();

    // BUSCA CRT EMPRESA
    $banco = new c_banco();
    $sql = "select * from amb_empresa where (centrocusto=".$this->m_empresacentrocusto.")";
    $emp = $banco->exec_sql($sql);
    $crt=$emp[0]['REGIMETRIBUTARIO'];


    $sql  = "SELECT * FROM EST_NAT_OP_TRIBUTO ";
    $sql .= "WHERE (CENTROCUSTO =".$this->m_empresacentrocusto.") AND (IDNATOP =".$natOp.") AND (UF='".$uf."') AND (PESSOA='".$tipoPessoa."') AND ";
    if ($crt=='3'):
        $sql .= "(ORIGEM='".$origem."') AND (TRIBICMS='".$tribIcms."') AND ((NCM='".$ncm."') OR (NCM='')) AND ((CEST='".$cest."') OR (CEST=''));";
    else:    
        $sql .= "(ORIGEM='".$origem."');";
    endif;
    
   // echo strtoupper($sql);
    $banco->exec_sql($sql);
    $banco->close_connection();
    $arrTributos =  $banco->resultado;
    if (isset($arrTributos)):

        // seta aliquotas
        $objNfProd->setCfop($arrTributos[0]['CFOP']);
        $objNfProd->setAliqIcms($arrTributos[0]['ALIQICMS'], true);
        $objNfProd->setPercReducaoBc($arrTributos[0]['PERCREDUCAOBC'], true);
        $objNfProd->setModBc($arrTributos[0]['MODBC']);
        $objNfProd->setPercDiferido($arrTributos[0]['PERCDIFERIDO'], true);
        $objNfProd->setModBcSt($arrTributos[0]['MODBCST']);
        $objNfProd->setPercMvaSt($arrTributos[0]['MVAST'], true);
        $objNfProd->setBcFcpSt($arrTributos[0]['BCFCPST'], true);
        $objNfProd->setAliqFcpSt($arrTributos[0]['ALIQFCPST'], true);
        $objNfProd->setValorFcpSt($arrTributos[0]['VALORFCPST'], true);                
        $objNfProd->setPercReducaoBcSt($arrTributos[0]['PERCREDUCAOBCST'], true);
        $objNfProd->setAliqIcmsSt($arrTributos[0]['ALIQICMSST'], true);
        $objNfProd->setAliqIpi($arrTributos[0]['ALIQIPI'], true);
        $objNfProd->setInsideIpiBc($arrTributos[0]['INSIDEIPIBC']);
        $objNfProd->setCstPis($arrTributos[0]['CSTPIS']);
        $objNfProd->setAliqPis($arrTributos[0]['ALIQPIS'], true);
        $objNfProd->setCstCofins($arrTributos[0]['CSTCOFINS']);
        $objNfProd->setAliqCofins($arrTributos[0]['ALIQCOFINS'], true);
        $objNfProd->setCBenef($arrTributos[0]['CBENEF']);

        // inicializa campos , SEM PARAMETRO DE FORMATAÇÃO PARA TRAZER DEFAULT
        $totalProduto = $objNfProd->getTotal('B');
        $descontoProduto = $objNfProd->getDesconto('B');
        $aliqIcms = $objNfProd->getAliqIcms('B');
        $percReducaoBc = $objNfProd->getPercReducaoBc('B');
        $percDiferido = $objNfProd->getPercDiferido('B');
        $mvaSt = $objNfProd->getPercMvaSt('B');
        $bcFcpSt = $objNfProd->getBcFcpSt('B');
        $aliqFcpSt = $objNfProd->getAliqFcpSt('B');
        $valorFcpSt = $objNfProd->getValorFcpSt('B');                
        $percReduacaoBcSt = $objNfProd->setPercReducaoBcSt('B');
        $aliqIcmsSt = $objNfProd->setAliqIcmsSt('B');
        $aliqIpi = $objNfProd->getAliqIpi('B');
        $insideIpiBc = $objNfProd->getInsideIpiBc('B');
        $vlIcms = 0;
        $vlIpi = 0;
        $vlIcmsDiferido = 0;
        $vlIcmsOperacao = 0;
        $vlBcSt = 0;
        $vlIcmsSt = 0;
        $vlBcStRet = 0;
        $vlIcmsStRet = 0;
        $cstPis = $objNfProd->getCstPis();
        $aliqPis = $objNfProd->getAliqPis('B');
        $vlPis = 0;
        $cstCofins = $objNfProd->getCstCofins();
        $aliqCofins = $objNfProd->getAliqCofins('B');
        $vlCofins = 0;

        
        if ($crt!='3'):
            $objNfProd->setTribIcms($arrTributos[0]['TRIBICMS']);
            $bcIcms = 0;
            $bcPis = 0;
            $bcCofins = 0;
        else:    
            $bcIcms = $totalProduto - $descontoProduto;
            $bcPis = $totalProduto - $descontoProduto;
            $bcCofins = $totalProduto - $descontoProduto;
        endif;
        
        // calcula IPI
        //o montante do IPI:

        // 1 - não integra a BC do ICMS quando o produto for destinado a posterior comercialização, industrialização ou outra saída tributada;
        // 2 - integra a BC do ICMS quando o produto for destinado a consumidor final, ativo imobilizado 
        $objNfProd->setValorIpi(0);
        if ($aliqIpi>0):
            $vlIpi = ($aliqIpi/100)*$totalProduto;
            if ($insideIpiBc=="S"):
                $bcIcms += $vlIpi;
            endif;
            $objNfProd->setValorIpi($vlIpi);
        endif;

        switch ($arrTributos[0]['TRIBICMS']){
            case '00': // tributado integralmente
                $vlIcms = ($aliqIcms/100)*$bcIcms;
                // observacao
                break;
            case '10': // Tributada e com cobrança do ICMS por substituição tributária
                $vlIcms = ($aliqIcms/100)*$bcIcms;
                $vlBcSt = $bcIcms;
                if ($insideIpiBc=="N"): // soma vl ipi na base de calculo de ST
                    $vlBcSt += $vlIpi;
                endif;
                $vlBcSt = ($vlBcSt * $mvaSt); // aplica indice mva bc st
                $vlBcSt -= ($vlBcSt*($percReduacaoBcSt/100)); // aplica redução bc st
                $vlIcmsSt = (($aliqIcmsSt/100)*($vlBcSt)) - $vlIcms; //calcula icms st

                break;
            case '20': // Tributação com redução de base de cálculo
                $bcIcms -= ($bcIcms*($percReduacaoBc/100)); // aplica reducao
                $vlIcms = ($aliqIcms/100)*$bcIcms;

                break;
            case '30': // Tributação Isenta ou não tributada e com cobrança do ICMS por substituição tributária
                $vlIcms = ($aliqIcms/100)*$bcIcms;
                $vlBcSt = $bcIcms;
                if ($insideIpiBc=="N"): // soma vl ipi na base de calculo de ST
                    $vlBcSt += $vlIpi;
                endif;
                $vlBcSt = ($vlBcSt * $mvaSt); // aplica indice mva bc st
                $vlBcSt -= ($vlBcSt*($percReduacaoBcSt/100)); // aplica redução bc st
                $vlIcmsSt = (($aliqIcmsSt/100)*($vlBcSt)) - $vlIcms; //calcula icms st
                $bcIcms = 0;
                $vlIcms = 0;
                break;
            case '40': // Tributação Isenta, Não tributada ou Suspensão.
            case '41': // Tributação Isenta, Não tributada ou Suspensão.
            case '50': // Tributação Isenta, Não tributada ou Suspensão.
                break;
            case '51': // Tributação com Diferimento (a exigência do preenchimento das
                       //informações do ICMS diferido fica a critério de cada UF).

                $bcIcms = ($percReducaoBc/100)*$totalProduto;
                $vlIcmsDiferido = ($percDiferido/100)*$bcIcms;
                $vlIcmsOperacao = ($aliqIcms/100)*$bcIcms;
                $vlIcms = $vlIcmsOperacao-$vlIcmsDiferido;
                break;
            case '60': // Tributação ICMS cobrado anteriormente por substituição tributária
                // buscar valor de impostos retido na nf de entrada
                /*
                O CST 060 significa: mercadoria de origem nacional, e ICMS cobrado anteriormente por Substituição Tributária.
                Como o ICMS já foi cobrado anteriormente, esse imposto NÃO deve ser destacado na próxima circulação da mercadoria, 
                em operações internas. Então, utiliza-se o CST 060. 
                O ICMS devido por este contribuinte já foi pago na entrada da mercadoria, por Substituição Tributária, 
                com margem de lucro e já recolhido aos cofres estaduais, pelo remetente. 
                Portanto o sistema está correto em não destacar “Base de Cálculo do ICMS” e “Valor do ICMS”, 
                porque o imposto já foi recolhido por ST. 
                É necessário, porém, que seja informado no campo “Dados Adicionais – Informações Complementares”, da nota fiscal, 
                o dispositivo legal que permite o não destaque do ICMS; em SC, o dispositivo legal é: 

                “ Imposto Retido por Substituição Tributária – RICMS-SC/01 – Anexo 3”. 

                Em toda nota fiscal, modelo 1, 1-A ou 55 (eletrônica), é obrigatório informar qual o dispositivo legal que permite 
                o não destaque do ICMS. 
                Há também nos Regulamentos de ICMS, uma determinação que seja indicada no campo “Dados Adicionais – 
                Informações Complementares”, quando da emissão dos mesmos modelos de notas fiscais acima mencionados, 
                a base de cálculo e o valor do imposto retido, salvo nas saídas destinadas a não contribuinte. 

                Essas informações são obtidas na NF de compra, onde o ICMS Substituto é cobrado. 
                Se faz necessária esse informação porque o destinatário poderá creditar esse ICMS, 
                no caso de mercadoria para industrialização ou ativo imbolizado. 

                Quem utiliza o CST 060, é o Contribuinte Substituído, ou seja, aquele que pagou antecipadamente o 
                ICMS que seria de sua obrigação, quando da saída posterior da mercadoria.                  

                 */
                $bcIcms = 0;
                // ******* buscat o valor st retido na nf de entrada
                $vlBcStRet = 0;
                $vlIcmsStRet = 0;
                break;
            case '70': // Tributação ICMS com redução de base de cálculo e cobrança
                       // do ICMS por substituição tributária
                $bcIcms -= ($bcIcms*($percReduacaoBc/100)); // aplica reducao Bc
                $vlIcms = ($aliqIcms/100)*$bcIcms;
                $vlBcSt = $bcIcms;
                if ($insideIpiBc=="N"): // soma vl ipi na base de calculo de ST
                    $vlBcSt += $vlIpi;
                endif;
                $vlBcSt = ($vlBcSt * $mvaSt); // aplica indice mva bc st
                $vlBcSt -= ($vlBcSt*($percReduacaoBcSt/100)); // aplica redução bc st
                $vlIcmsSt = (($aliqIcmsSt/100)*$vlBcSt) - $vlIcms; //calcula icms st


                break;
            case '90': // Tributação ICMS: Outros
                $bcIcms -= ($bcIcms*($percReduacaoBc/100)); // aplica reducao Bc
                $vlIcms = ($aliqIcms/100)*$bcIcms;
                $vlBcSt = $bcIcms;
                if ($insideIpiBc=="N"): // soma vl ipi na base de calculo de ST
                    $vlBcSt += $vlIpi;
                endif;
                $vlBcSt = ($vlBcSt * $mvaSt); // aplica indice mva bc st
                $vlBcSt -= ($vlBcSt*($percReduacaoBcSt/100)); // aplica redução bc st
                $vlIcmsSt = (($aliqIcmsSt/100)*$vlBcSt) - $vlIcms; //calcula icms st


                break;
        }

        // calculo PIS
        switch ($cstPis){
            case '01': // Operação Tributável (base de cálculo = valor da operação alíquota normal (cumulativo/não cumulativo)); 
            case '02': // Operação Tributável (base de cálculo = valor da operação (alíquota diferenciada)); 
                $vlPis = ($bcPis * $aliqPis) / 100;
                break;
            case '03': //Operação Tributável (base de cálculo = quantidade vendida x alíquota por unidade de produto)
                $bcPis = $objNfProd->getQuant();
                $vAliqProd = $aliqPis;
                $vlPis = ($bcPis * $vAliqProd);
                break;
            case '04': 
            case '05': 
            case '06': 
            case '07': 
            case '08': 
            case '09': 
                $bcPis = 0;
                $aliqPis = 0;
                $vlPis = 0;
                break;
            default :
                $vlPis = ($bcPis * $aliqPis) / 100;
        }
        
        // calculo COFINS
        switch ($cstCofins){
            case '01': // Operação Tributável (base de cálculo = valor da operação alíquota normal (cumulativo/não cumulativo)); 
            case '02': // Operação Tributável (base de cálculo = valor da operação (alíquota diferenciada)); 
                $vlCofins = ($bcCofins * $aliqCofins) / 100;
                break;
            case '03': //Operação Tributável (base de cálculo = quantidade vendida x alíquota por unidade de produto)
                $bcPis = $objNfProd->getQuant();
                $vAliqProd = $aliqCofins;
                $vlCofins = ($bcCofins * $vAliqProd);
                break;
            case '04': 
            case '05': 
            case '06': 
            case '07': 
            case '08': 
            case '09': 
                $bcCofins = 0;
                $aliqCofins = 0;
                $vlCofins = 0;
                break;
            default :
                $vlCofins = ($bcCofins * $aliqCofins) / 100;
        }
        
        $objNfProd->setBcIcms($bcIcms, true);
        $objNfProd->setValorIcms($vlIcms, true);

        $objNfProd->setValorIcmsDiferido($vlIcmsDiferido, true);
        $objNfProd->setValorIcmsOperacao($vlIcmsOperacao, true);

        $objNfProd->setValorBcSt($vlBcSt, true);
        $objNfProd->setValorIcmsSt($vlIcmsSt, true);

        $objNfProd->setBcPis($bcPis, true);
        $objNfProd->setValorPis($vlPis, true);
        $objNfProd->setBcCofins($bcCofins, true);
        $objNfProd->setValorCofins($vlCofins, true);
        
        return true;
    else:
        return false;
    endif;
    
    } //fim calculaImpostos

//---------------------------------------------------------------
//---------------------------------------------------------------

    public function existeNotaFiscal() {

        $sql = "SELECT * ";
        $sql .= "FROM est_nota_fiscal_produto ";
        $sql .= "WHERE (idNf = '" . $this->getIdNf() . "' AND codProduto = " . $this->getCodProduto() . ")";
//	ECHO $sql;

        $banco = new c_banco();
        $banco->exec_sql($sql);
        $banco->close_connection();
        return is_array($banco->resultado);
    }
//fim existeDocumento
//---------------------------------------------------------------
//---------------------------------------------------------------

    public function existeProdutoConferencia($conn=null) {

        $sql = "SELECT * ";
        $sql .= "FROM est_nota_fiscal_produto ";
        $sql .= "WHERE (idNf = '" . $this->getIdNf() . "' AND dataconferencia is null)";
//	ECHO $sql;

        $banco = new c_banco();
        $banco->exec_sql($sql, $conn);
        $banco->close_connection();
        return is_array($banco->resultado);
    }
//fim existeDocumento
//---------------------------------------------------------------
//---------------------------------------------------------------
    public function existeDataConferencia() {

        if (($this->getDataConferencia() == '0000-00-00 00:00:00') || ($this->getDataConferencia() == ''))
            return 0;
        else
            return 1;
    }

//fim existeDocumento
//---------------------------------------------------------------
//---------------------------------------------------------------
    public function select_nota_fiscal_produto() {

        $sql = "SELECT DISTINCT * ";
        $sql .= "FROM est_nota_fiscal_produto ";
        $sql .= "WHERE (ID = " . $this->getId() . ")";

        //echo strtoupper($sql)."<BR>";
        $banco = new c_banco();
        $banco->exec_sql($sql);
        $banco->close_connection();
        return $banco->resultado;
    }
//fim select_nota_fiscal_produto
//---------------------------------------------------------------
//---------------------------------------------------------------
    public function select_nota_fiscal_produto_nf($conn=null) {

        // $sql = "SELECT DISTINCT N.ID,N.IDNF,N.CODPRODUTO,N.DESCRICAO,N.UNIDADE,N.QUANT,N.UNITARIO,N.DESCONTO,N.TOTAL,N.ORIGEM,N.TRIBICMS,N.NCM,N.CEST,N.CFOP,N.ALIQICMS,N.PERCREDUCAOBC,N.MODBC,N.BCICMS,N.VALORICMS,N.ALIQIPI,N.VALORIPI,N.PERCDIFERIDO, ";
        // $sql .= "N.VALORICMSDIFERIDO,N.VALORICMSOPERACAO,N.MODBCST,N.PERCMVAST,N.PERCREDUCAOBCST,N.VALORBCST,N.ALIQICMSST,N.VALORICMSST,N.VALORTOTALTRIBUTOS,N.VALORBCSTRETIDO,N.VALORICMSSTRETIDO,N.CUSTOPRODUTO, ";
        // $sql .= "N.LOTE,N.DATAFABRICACAO,N.DATAVALIDADE,N.CSTPIS,N.BCPIS,N.ALIQPIS,N.VALORPIS,N.CSTCOFINS,N.BCCOFINS,N.ALIQCOFINS,N.VALORCOFINS, p.CODIGOBARRAS, p.CODPRODUTOANVISA, ";
        $sql = "SELECT DISTINCT N.*, ";
        $sql .= "p.CODIGOBARRAS, p.CODPRODUTOANVISA, p.CODIGOBARRAS, p.CODPRODUTOANVISA FROM est_nota_fiscal_produto n ";
        $sql .= "inner join est_produto p on(n.codproduto = p.codigo) ";
        $sql .= "WHERE (n.IDNF = " . $this->getIdNf() . ") ";
        //$sql .= "ORDER BY p.codfabricante";
         // ECHO strtoupper($sql);
        $banco = new c_banco;
        $banco->exec_sql($sql, $conn);
        $banco->close_connection();
        return $banco->resultado;

//	$this->exec_sql($sql);
//	return $this->resultado;
    }

//fim select_nota_fiscal_produto_nf

//---------------------------------------------------------------
//---------------------------------------------------------------
    public function incluiNotaFiscalProduto($conn=null) {

        $banco = new c_banco;

        if ($banco->gerenciadorDB == 'interbase') {
            $this->setId($banco->geraID("EST_GEN_ID_NF_PRODUTO"));
            $sql = "INSERT INTO est_nota_fiscal_produto (ID,";
        } else {
            $sql = "INSERT INTO est_nota_fiscal_produto (";
        }


        $sql .= "
		IDNF, 
		CODPRODUTO, 
		Descricao, 
		Unidade, 
		Quant, 
		Unitario, 
		Desconto, 
		Total, 
		Origem,
		Cfop, 
		TribIcms,
		bcIcms, 
		ValorIcms, 
		ValorIpi, 
		AliqIcms, 
		AliqIpi, 
		cstPis, 
		bcPis, 
		AliqPis, 
		valorPis, 
		cstCofins, 
		bcCofins, 
		AliqCofins, 
		valorCofins, 
		CustoProduto, 
		Ncm, 
		cest, 
        NrSerie,
        lote,
        bcfcpufdest, 
        aliqfcpufdest,
        valorfcpufdest,
        bcicmsufdest,
        aliqicmsufdest,
        aliqicmsinter,
        aliqicmsinterpart,
        valoricmsufdest,
        valoricmsufremet,
		dataFabricacao,
		dataValidade,
		dataGarantia,
		ordem,
		projeto, 
        DATACONFERENCIA,
        cbenef) ";

        if ($banco->gerenciadorDB == 'interbase') {
            $sql .= "VALUES (" . $this->getId() . ", ";
        } else {
            $sql .= "VALUES (";
        }
        $sql .=
                $this->getIdNf() . ", "
                . $this->getCodProduto() . ", '"
                . $this->getDescricao() . "', '"
                . $this->getUnidade() . "', "
                . $this->getQuant('B') . ", "
                . $this->getUnitario('B') . ", "
                . $this->getDesconto('B') . ", "
                . $this->getTotal('B') . ", '"
                . $this->getOrigem() . "', '"
                . $this->getCfop() . "', '"
                . $this->getTribIcms() . "', "
                . $this->getBcIcms('B') . ", "
                . $this->getValorIcms('B') . ", "
                . $this->getValorIpi('B') . ", "
                . $this->getAliqIcms('B') . ", "
                . $this->getAliqIpi('B') . ", '"
                . $this->getCstPis() . "', "
                . $this->getBcPis('B') . ", "
                . $this->getAliqPis('B') . ", "
                . $this->getValorPis('B') . ", '"
                . $this->getCstCofins() . "', "
                . $this->getBcCofins('B') . ", "
                . $this->getAliqCofins('B') . ", "
                . $this->getValorCofins('B') . ", "
                . $this->getCustoProduto('B') . ", '"
                . $this->getNcm() . "', '"
                . $this->getCest() . "', '"
                . $this->getNrSerie() . "' , '"
                . $this->getLote() . "', '"
                . $this->getBcFcpUfDest('B') . "', '"
                . $this->getAliqFcpUfDest('B') . "', '"
                . $this->getValorFcpUfDest('B') . "', '"
                . $this->getBcIcmsUfDest('B') . "', '"
                . $this->getAliqIcmsUfDest('B') . "', '"
                . $this->getAliqIcmsInter('B') . "', '"
                . $this->getAliqIcmsInterPart('B') . "', '"                        
                . $this->getValorIcmsUfDest('B') . "', '"
                . $this->getValorIcmsUFRemet('B') . "', ";            

        if ($this->getDataFabricacao('B') == ''):
            $sql .= "null, ";
        else:
            $sql .= "'" . $this->getDataFabricacao('B') . "', ";
        endif;
        if ($this->getDataValidade('B') == ''):
            $sql .= "null, ";
        else:
            $sql .= "'" . $this->getDataValidade('B') . "', ";
        endif;
        if ($this->getDataGarantia('B') == ''):
            $sql .= "null, '";
        else:
            $sql .= "'" . $this->getDataGarantia('B') . "', '";
        endif;
        $sql .= $this->getOrdem() . "', '". $this->getProjeto() . "', ";
        if ($this->getDataConferencia('B') == ''):
            $sql .= "null,  ";
        else:
            $sql .= "'" .$this->getDataConferencia('B') . "',  ";
        endif;
        $sql .= "'".$this->getCBenef() . "' ); ";


        // ECHO strtoupper($sql)."<br>";
        $res_nf = $banco->exec_sql($sql, $conn);
        $banco->close_connection();

        if ($res_nf > 0) {
            return $banco->result;
        } else {
            return 'Os dados da Nota Fiscal ' . $this->getDescricao() . ' n&atilde;o foram cadastrados!';
        }
    }

// fim incluiNotaFiscal
//---------------------------------------------------------------
//---------------------------------------------------------------
    public function alteraDataConferencia() {
        $this->setDataConferencia(date("d/m/Y H:i:s"));
        $sql = "UPDATE est_nota_fiscal_produto ";
        $sql .= " SET dataConferencia = '" . $this->getDataConferencia('B') . "'";
        $sql .= " WHERE (IdNf = " . $this->getIdNf() . ") AND (ID = " . $this->getId() . ") ";
//	$sql .= " WHERE (IdNf = ".$this->getIdNf().") AND (codProduto = ".$this->getCodProduto().") ";
        //echo strtoupper($sql);
        $banco = new c_banco;

        $res_nf = $banco->exec_sql($sql);

        $banco->close_connection();

        if ($res_nf > 0) {
            return 'PRODUTO RECEBIDO';
        } else {
            return 'Os dados do Produto n&atilde;o foram alterados!';
        }
    }

//---------------------------------------------------------------
//---------------------------------------------------------------
    public function alteraNotaFiscalProduto($conn=null) {

        $sql = "UPDATE est_nota_fiscal_produto ";
        $sql .= "SET  ";
        $sql .= "codProduto = '" . $this->getCodProduto() . "', ";
        $sql .= "descricao = '" . $this->getDescricao() . "', ";
        $sql .= "Unidade = '" . $this->getUnidade() . "', ";
        $sql .= "Quant = " . $this->getQuant('B') . ", ";
        $sql .= "Unitario = " . $this->getUnitario('B') . ", ";
        $sql .= "Desconto = " . $this->getDesconto('B') . ", ";
        $sql .= "Total = " . $this->getTotal('B') . ", ";
        $sql .= "Origem = '" . $this->getOrigem() . "', ";
        $sql .= "Cfop = " . $this->getCfop() . ", ";
        $sql .= "tribIcms = '" . $this->getTribIcms() . "', ";
        $sql .= "bcIcms = " . $this->getBcIcms('B') . ", ";
        $sql .= "ValorIcms = " . $this->getValorIcms('B') . ", ";
        $sql .= "ValorIpi = " . $this->getValorIpi('B') . ", ";
        $sql .= "AliqIcms = " . $this->getAliqIcms('B') . ", ";
        $sql .= "percreducaobc = " . $this->getPercReducaoBc('B') . ", ";
        $sql .= "percmvast = " . $this->getPercMvaSt('B') . ", ";
        $sql .= "bcfcpst = " . $this->getBcFcpSt('B') . ", ";        
        $sql .= "aliqfcpst = " . $this->getAliqFcpSt('B') . ", ";        
        $sql .= "valorfcpst = " . $this->getValorFcpSt('B') . ", ";                        
        $sql .= "percreducaobcst = " . $this->getPercReducaoBcSt('B') . ", ";
        $sql .= "aliqicmsst = " . $this->getAliqIcmsSt('B') . ", ";
        $sql .= "valorbcst = " . $this->getValorBcSt('B') . ", ";
        $sql .= "valoricmsst = " . $this->getValorIcmsSt('B') . ", ";
        $sql .= "AliqIpi = " . $this->getAliqIpi('B') . ", ";
        $sql .= "cstpis = '" . $this->getCstPis() . "', ";
        $sql .= "bcpis = " . $this->getBcPis('B') . ", ";
        $sql .= "aliqpis = " . $this->getAliqPis('B') . ", ";
        $sql .= "valorpis = " . $this->getValorPis('B') . ", ";
        $sql .= "cstcofins = '" . $this->getCstCofins() . "', ";
        $sql .= "bccofins = " . $this->getBcCofins('B') . ", ";
        $sql .= "aliqcofins = " . $this->getAliqCofins('B') . ", ";
        $sql .= "valorcofins = " . $this->getValorCofins('B') . ", ";
        $sql .= "bcfcpufdest = " . $this->getBcFcpUfDest() . ", ";
        $sql .= "aliqfcpufdest = " . $this->getAliqFcpUfDest() . ", ";
        $sql .= "valorfcpufdest = " . $this->getValorFcpUfDest() . ", ";
        $sql .= "bcicmsufdest = " . $this->getBcIcmsUfDest() . ", ";
        $sql .= "aliqicmsufdest = " . $this->getAliqIcmsUfDest() . ", ";
        $sql .= "aliqicmsinter = " . $this->getAliqIcmsInter() . ", ";
        $sql .= "aliqicmsinterpart = " . $this->getAliqIcmsInterPart() . ", ";                        
        $sql .= "valoricmsufdest = " . $this->getValorIcmsUfDest() . ", ";
        $sql .= "valoricmsufremet = " . $this->getValorIcmsUFRemet() . ", ";        
        $sql .= "Ncm = '" . $this->getNcm() . "', ";
        $sql .= "Cest = '" . $this->getCest() . "', ";
        $sql .= "NrSerie = '" . $this->getNrSerie() . "', ";
        $sql .= "Lote = '" . $this->getLote() . "', ";

        if ($this->getDataConferencia('B') == '')
            $sql .= "DATACONFERENCIA = null, ";
        else
            $sql .= "DATACONFERENCIA = '" . $this->getDataConferencia('B') . "', ";
        if ($this->getDataFabricacao('B') == '')
            $sql .= "DATAFABRICACAO = null, ";
        else
            $sql .= "DATAFABRICACAO = '" . $this->getDataFabricacao('B') . "', ";
        if ($this->getDataValidade('B') == '')
            $sql .= "DATAVALIDADE = null, ";
        else
            $sql .= "DATAVALIDADE = '" . $this->getDataValidade('B') . "', ";
        if ($this->getDataGarantia('B') == '')
            $sql .= "DATAGARANTIA = null, ";
        else
            $sql .= "DATAGARANTIA = '" . $this->getDataGarantia('B') . "', ";
        $sql .= "ORDEM = '" . $this->getOrdem() . "', ";
        $sql .= "PROJETO = '" . $this->getProjeto() . "', ";
        $sql .= "CBENEF = '" . $this->getCBenef() . "' ";
        $sql .= "WHERE id = " . $this->getId() . ";";

        // echo strtoupper($sql);
        $banco = new c_banco;

        $res_nfProduto = $banco->exec_sql($sql, $conn);
        $banco->close_connection();

	if($res_nfProduto > 0){
            return true;
        } else {
            return 'Os dados do Produto ' . $this->getDescricao() . ' n&atilde;o foram alterados!';
        }
    }

// fim alteraNotaFiscal
//---------------------------------------------------------------
//---------------------------------------------------------------
    public function excluiNotaFiscalProduto() {

        $sql = "DELETE FROM est_nota_fiscal_produto ";
        $sql .= "WHERE id = " . $this->getId() . ";";
        $banco = new c_banco;
        $res_nf = $banco->exec_sql($sql);
        $banco->close_connection();
        // echo strtoupper($sql);
        if ($res_nf > 0) {
            return 'Produto Deletado com sucesso.';
        } else {
            return 'Os dados da Nota Fiscal ' . $this->getDescricao() . ' n&atilde;o foram excluidos!';
        }
    }

// fim excluiNotaFiscal




    
    
    
    
    
//---------------------------------------------------------------
//não utilizado
//---------------------------------------------------------------
    function mudaSituacaoChamado($id) {
        $classAtPecas = new c_atPecas();
        $classAtPecas->setId($id);
        $atPecas = $classAtPecas->select_at_pecas();
        $status = true; //flag para atualizar o status
        for ($i = 0; $i < count($atPecas); $i++) {
            $sit = $atPecas[$i]['SITUACAO'];
            if ((($sit == 'PECARECEBIDA') || ($sit == 'RESERVAR') || ($sit == 'RESERVADO') || ($sit == 'APLICADO') || ($sit == 'DESFEITO')) && ($status == true)) {
                
            } else {
                $status = false;
            }//if
        }//for
        if ($status) {
            $classOs = new c_ordemServico;
            $parametros = new c_banco;
            $parametros->setTab("CAT_PARAMETROS");
            $situacao = $parametros->getParametros("SITPECARECEBIDA");
            $parametros->close_connection();
            $classOs->setId($id);
            $classOs->setSituacao($situacao);
            $classOs->alteraOrdemServicoSituacao();
            $classOs->lancaAcompanhamento("Alteracao da Situacao - Nova Situacao: PECA RECEBIDA", "", $this->m_userid);
        }//if
    }

//mudaSituacaoChamado    
//---------------------------------------------------------------
//pedquisa pecas chamado - distribui os
//---------------------------------------------------------------

    public function select_nota_fiscal_produto_chamado() {

        $sql = "SELECT DISTINCT * ";
        $sql .= "FROM est_nota_fiscal_produto ";
        $sql .= "WHERE (ordem = '" . $this->getOrdem() . "')";

        //echo strtoupper($sql)."<br>";
        $banco = new c_banco();
        $banco->exec_sql($sql);
        $banco->close_connection();
        return $banco->resultado;
    }

//fim select_nota_fiscal_produto_chamado

    /**
     * <b> select utilizado: p_relatorio_gerencial </b>
     * @name     select_consolidacao_fiscal
     * @param    date dataInicio 
     * @param    date dataFim
     */
    public function select_consolidacao_fiscal($dataIni, $dataFim, $desc=null) {
        
        $sql = "SELECT N.NUMERO,N.EMISSAO,N.NATOPERACAO,  ";//F.DATACONFERENCIA,
        $sql .= "P.CODFABRICANTE, P.DESCRICAO, O.*, ";
        $sql .= "L.NUMLOTE, L.DATAENTREGA, L.NUMNF, U.NOMEREDUZIDO ";
        $sql .= "from EST_PRODUTO_ESTOQUE O ";
        $sql .= "INNER JOIN EST_PRODUTO P ON (O.CODPRODUTO = P.CODIGO) ";
        $sql .= "INNER JOIN EST_NOTA_FISCAL N ON (N.ID = O.IDNFENTRADA) ";
        //$sql .= "INNER JOIN EST_NOTA_FISCAL_PRODUTO F ON (F.IDNF = O.IDNFENTRADA) ";
        $sql .= "LEFT JOIN EST_LOTE L ON (L.ID = O.IDLOTE) ";
        $sql .= "LEFT JOIN AMB_USUARIO U ON (U.USUARIO = O.USERPRODUTO) ";
        $sql .= "WHERE n.emissao >= '".c_date::convertDateBd($dataIni, $this->m_banco)."' ";
        $sql .= "and n.emissao <= '".c_date::convertDateBd($dataFim, $this->m_banco)."'; ";
       // echo strtoupper($sql)."<BR>";
        $banco = new c_banco();
        $banco->exec_sql($sql);
        $banco->close_connection();
        return $banco->resultado;
    }// fim select_consolidacao_fiscal
    
    /**
     * <b> select utilizado: p_relatorio_gerencial </b>
     * @name     select_consolidacao_fiscal
     * @param    date dataInicio 
     * @param    date dataFim
     */
    public function select_consolidacao_produtos($letra, $grupo = true, $desc=null) {
        
        $par = explode("|", $letra);
        $dataIni = c_date::convertDateTxt($par[3]);
        $dataFim = c_date::convertDateTxt($par[4]);
        
        $sql = "SELECT N.NUMERO, P.CODPRODUTO, P.DESCRICAO, P.UNITARIO, P.CFOP, ";
        $sql .= "ALIQICMS, ALIQPIS, ALIQCOFINS, N.EMISSAO, N.ORIGEM, N.DOC, C.NOME, C.NOMEREDUZIDO, ";
        if ($grupo==true):
            $sql .= "sum(P.VALORICMS) as ICMS, sum(P.VALORPIS) as PIS, sum(P.VALORCOFINS) as COFINS, ";
            $sql .= "SUM(P.QUANT) AS QUANT, sum(P.TOTAL) AS TOTAL FROM EST_NOTA_FISCAL_PRODUTO P ";
        else:
            $sql .= "P.VALORICMS as ICMS, P.VALORPIS as PIS, P.VALORCOFINS as COFINS, ";
            $sql .= "P.QUANT, P.TOTAL FROM EST_NOTA_FISCAL_PRODUTO P ";
        endif;
        $sql .= "inner JOIN EST_NOTA_FISCAL N ON (N.ID=P.IDNF) ";
        $sql .= "inner JOIN FIN_CLIENTE C ON (C.CLIENTE=N.PESSOA) ";

        $iswhere = false;

        if ($par[5] != '') { // CASO PESQUISA POR NUMERO DA NF
            $sql .= "WHERE (N.NUMERO = '" . $par[5] . "') ";
        } else {
            
            if ($par[3] != '') { // PERIODO INICIAL DE PESQUISA
                $iswhere = true;
                $sql .= "WHERE (N.EMISSAO >= '" . $dataIni . "') ";
            }
            
            if ($par[4] != '') { // PERIODO FINAL DE PESQUISA
                if ($iswhere) {
                    $sql .= "AND (N.EMISSAO <= '" . $dataFim . " 23:59:59') ";
                } else {
                    $iswhere = true;
                    $sql .= "WHERE (N.EMISSAO <= '" . $dataFim . " 23:59:59') ";
                }
            }
            
            if (($par[0] != '') and ( $par[0] != '0')) { // FILIAL
                if ($iswhere) {
                    $sql .= "AND (N.CENTROCUSTO= " . $par[0] . ") ";
                } else {
                    $iswhere = true;
                    $sql .= "WHERE (N.CENTROCUSTO = " . $par[0] . ") ";
                }
            }// FIM FILIAL

            if ($par[1] != '') {  //TIPO DA NF 0-ENTRADA, 1 SAIDA
                if ($iswhere) {
                    $sql .= "AND (N.TIPO= " . $par[1] . ") ";
                } else {
                    $iswhere = true;
                    $sql .= "WHERE (N.TIPO = " . $par[1] . ") ";
                }
            }// FIM TIPO DA NF

            if (($par[2] != '') and ( $par[2] != '0')) { // SITUACAO DA NOTA
                if ($iswhere) {
                    $sql .= "AND (N.SITUACAO= '" . $par[2] . "') ";
                } else {
                    $iswhere = true;
                    $sql .= "WHERE (N.SITUACAO = '" . $par[2] . "') ";
                }
            }
        } // if numero
        
        if ($grupo==true):
            $sql .= "GROUP BY P.CODPRODUTO";
        else:
            $sql .= "ORDER BY N.NUMERO";
        endif;
       // echo strtoupper($sql)."<BR>";
        $banco = new c_banco();
        $banco->exec_sql($sql);
        $banco->close_connection();
        return $banco->resultado;
    }// fim select_consolidacao_fiscal
    
//---------------------------------------------------------------
//---------------------------------------------------------------

    public function select_nota_fiscal_produto_letra($letra) {
        $par = explode("|", $letra);
        
        $sql = "SELECT DISTINCT * ";
        $sql .= "FROM est_nota_fiscal_produto ";
        $sql .= "WHERE (descricao LIKE '" . $letra . "%') ";
        $sql .= "AND (IDNF = " . $this->getIdNf() . ") ";
        $sql .= "ORDER BY descricao ";

        //echo $sql;
        $banco = new c_banco;
        $banco->exec_sql($sql);
        $banco->close_connection();
        return $banco->resultado;
    }

// fim select_nota_fiscal_produto_letra
}
//	END OF THE CLASS
?>
