<?php

/**
 * @package   astecv3
 * @name      c_contaBanco
 * @version   3.0.00
 * @copyright 2016
 * @link      http://www.admservice.com.br/
 * @author    Marcio Sergio da Silva<marcio.sergio@admservice.com.br>
 * @date      12/12/2016
 */

$dir = dirname(__FILE__);
include_once($dir . "/../../bib/c_tools.php");
//include_once($dir . "/../../bib/c_user.php");

//Class C_FIN_BANCO
class c_contaBanco extends c_user
{

    /*
    * TABLE NAME FIN_BANCO
    */
    // Campos tabela
    private $id                  = NULL; //smallint
    private $nomeInterno         = NULL; //varchar(30)
    private $nomeContaBanco      = NULL; //varchar(40)
    private $banco               = NULL; //varchar(6)
    private $agencia             = NULL; //varchar(6)
    private $contaCorrente       = NULL; //varchar(15)
    private $contato             = NULL; //varchar(15)
    private $descontoBonificacao = NULL; //decimal(5,2)
    private $multa               = NULL; //decimal(5,2)
    private $juros               = NULL; //decimal(5,2)
    private $protesto            = NULL; //smallint(6)
    private $nossoNumero         = NULL; //varchar(20)
    private $UltNossoNumero      = NULL; //varchar(20)
    private $numNoBanco          = NULL; //varchar(20)
    private $carteira            = NULL; //varchar(4)
    private $cnab                = NULL; //varchar(3)
    private $msgBloqueto         = NULL; //text

    //construtor
    function __construct()
    {
    }

    // METODOS DE SETS E GETS
    public function setId($id)
    {
        $this->id = $id;
    }
    public function getId()
    {
        return $this->id;
    }

    public function setNomeInterno($nomeInterno)
    {
        $this->nomeInterno = $nomeInterno;
    }
    public function getNomeInterno()
    {
        return $this->nomeInterno;
    }

    public function setNomeContaBanco($nomeContaBanco)
    {
        $this->nomeContaBanco = $nomeContaBanco;
    }
    public function getNomeContaBanco()
    {
        return $this->nomeContaBanco;
    }

    public function setBanco($banco)
    {
        $this->banco = $banco;
    }
    public function getBanco()
    {
        return $this->banco;
    }

    public function setAgencia($agencia)
    {
        $this->agencia = $agencia;
    }
    public function getAgencia()
    {
        return $this->agencia;
    }

    public function setContaCorrente($contaCorrente)
    {
        $this->contaCorrente = $contaCorrente;
    }
    public function getContaCorrente()
    {
        return $this->contaCorrente;
    }

    public function setContato($contato)
    {
        $this->contato = $contato;
    }
    public function getContato()
    {
        return $this->contato;
    }

    public function setNossoNumero($nossoNumero)
    {
        $this->nossoNumero = $nossoNumero;
    }
    public function getNossoNumero()
    {
        return $this->nossoNumero;
    }

    public function setUltimoNossoNumero($UltNossoNumero)
    {
        $this->UltNossoNumero = $UltNossoNumero;
    }
    public function getUltimoNossoNumero()
    {
        return $this->UltNossoNumero;
    }

    public function setDescontoBonificacao($descontoBonificacao)
    {
        $this->descontoBonificacao = $descontoBonificacao;
    }
    public function getDescontoBonificacao($format = null)
    {
        if (isset($this->descontoBonificacao)) {
            switch ($format) {
                case 'B':
                    return c_tools::moedaBd($this->descontoBonificacao);
                    break;
                case 'F':
                    return number_format((float) $this->descontoBonificacao, 2, ',', '.');
                    break;
                default:
                    return $this->descontoBonificacao;;
            }
        } else {
            return 0;
        }
    }

    public function setMulta($multa)
    {
        $this->multa = $multa;
    }
    public function getMulta($format = null)
    {
        if (isset($this->multa)) {
            switch ($format) {
                case 'B':
                    return c_tools::moedaBd($this->multa);
                    break;
                case 'F':
                    return number_format((float) $this->multa, 2, ',', '.');
                    break;
                default:
                    return $this->multa;;
            }
        } else {
            return 0;
        }
    }

    public function setJuros($juros)
    {
        $this->juros = $juros;
    }
    public function getJuros($format = null)
    {
        if (isset($this->juros)) {
            switch ($format) {
                case 'B':
                    return c_tools::moedaBd($this->juros);
                    break;
                case 'F':
                    return number_format((float) $this->juros, 4, ',', '.');
                    break;
                default:
                    return $this->juros;;
            }
        } else {
            return 0;
        }
    }

    public function setProtesto($protesto)
    {
        $this->protesto = $protesto;
    }
    public function getProstesto()
    {
        return $this->protesto;
    }

    public function setNumNoBanco($numNoBanco)
    {
        $this->numNoBanco = $numNoBanco;
    }
    public function getNumNoBanco()
    {
        return $this->numNoBanco;
    }

    public function setCarteira($carteira)
    {
        $this->carteira = $carteira;
    }
    public function getCarteira()
    {
        return $this->carteira;
    }

    public function setCnab($cnab)
    {
        $this->cnab = $cnab;
    }
    public function getCnab()
    {
        return $this->cnab;
    }

    public function setMsgBloqueto($msgBloqueto)
    {
        $this->msgBloqueto = $msgBloqueto;
    }
    public function getMsgBloqueto()
    {
        return $this->msgBloqueto;
    }

    //############### FIM SETS E GETS ###############

    /**
     * @name mod11
     * @description calcula digito verificador com base no calculo modulo 11
     * @param int $num - numero a ser calculado
     * @return int $count - numero de parcelas geradas
     */
    public function mod11($num, $base = 9, $r = 0)
    {
        $soma = 0;
        $fator = 2;
        /* Separacao dos numeros */
        for ($i = strlen($num); $i > 0; --$i) {
            // pega cada numero isoladamente
            $numeros[$i] = substr($num, $i - 1, 1);
            // Efetua multiplicacao do numero pelo falor
            $parcial[$i] = $numeros[$i] * $fator;
            // Soma dos digitos
            $soma += $parcial[$i];
            if ($fator == $base) { // restaura fator de multiplicacao para 2
                $fator = 1;
            }
            ++$fator;
        }

        //calculo digito bradesco
        $resto = $soma % 11;
        switch ($resto) {
            case 0:
                $digito = 0;
                break;
            case 1:
                $digito = 'P';
                break;
            default:
                $digito = 11 - $resto;
        }
        return $digito;
        /* Calculo do modulo 11 
        if ($r == 0) {
            $soma *= 10;
            $digito = $soma % 11;
            if ($digito == 10) {
                $digito = 0;
            }

            return $digito;
        } elseif ($r == 1) {
            $resto = $soma % 11;

            return $resto;
        }*/
    }

    /**
     * @name geraNumeroRemessa
     * @param int $conta - conta bancaria para gravar nosso numero
     * @param int $nr -  numero remessa a ser incrementado
     * @description atualzia o numero de remessa de cobrrança as ser enviado.
     */
    public function geraNumeroRemessa($conta, $nr)
    {

        $nr = $nr + 1;

        // SALVA NOSSO NUMERO
        $sql  = "UPDATE fin_conta ";
        $sql .= "SET  ";
        $sql .= "NUMREMESSA = '" . $nr . "' ";
        $sql .= "WHERE conta = " . $conta . ";";

        $contaBanco = new c_banco();
        $res_contaBanco = $contaBanco->exec_sql($sql);
        $contaBanco->close_connection();
        if ($res_contaBanco <= 0) :
            $nr = 0;
        endif;
        return $nr;
    } //fim geraNossoNumero

    /**
     * @name geraNossoNumero
     * @param int $conta - conta bancaria para gravar nosso numero
     * @param int $nn -  nosso numero a aser incrementado
     * @description atualiza o noso numero de cobrrança as ser enviado.
     */
    public function geraNossoNumero($conta, $nn)
    {

        $nn = $nn + 1;

        // SALVA NOSSO NUMERO
        $sql  = "UPDATE fin_conta ";
        $sql .= "SET  ";
        $sql .= "ULTIMONOSSONRO = '" . $nn . "' ";
        $sql .= "WHERE conta = " . $conta . ";";

        $contaBanco = new c_banco();
        $res_contaBanco = $contaBanco->exec_sql($sql);
        $contaBanco->close_connection();
        if ($res_contaBanco <= 0) :
            $nn = 0;
        endif;
        return $nn;
    } //fim geraNossoNumero

    /**
     * @name existeBanco
     * @description pesquisa se já existe código do contaBanco
     */
    public function existeContaBanco()
    {

        $sql  = "SELECT * ";
        $sql .= "FROM fin_conta ";
        $sql .= "WHERE (conta = " . $this->getId() . ")";
        //ECHO $sql;

        $contaBanco = new c_banco();
        $contaBanco->exec_sql($sql);
        $contaBanco->close_connection();
        return is_array($contaBanco->resultado);
    } //fim existeBanco

    /**
     * @name select_Banco
     * @description pesquisa se já existe código do contaBanco cadastrado
     */
    public function select_ContaBanco()
    {

        $sql  = "SELECT DISTINCT * ";
        $sql .= "FROM fin_conta ";
        $sql .= "WHERE (conta = " . $this->getId() . ") ";


        //echo $sql;
        $contaBanco = new c_banco();
        $contaBanco->exec_sql($sql);
        $contaBanco->close_connection();
        return $contaBanco->resultado;
    } //fim select_contaBanco

    /**
     * @name select_contaBanco_geral
     * @description pesquisa que retorna todos os registros cadastrado
     */
    public function select_contaBanco_geral()
    {
        $sql  = "SELECT DISTINCT * ";
        $sql .= "FROM fin_conta ";
        $sql .= "ORDER BY conta ";

        //	ECHO $sql;
        $contaBanco = new c_banco;
        $contaBanco->exec_sql($sql);
        $contaBanco->close_connection();
        return $contaBanco->resultado;
    } //fim select_contaBanco_geral

    /**
     * @name incluiBanco
     * @description faz a inclusão do registro cadastrado
     */
    public function incluiContaBanco()
    {

        $sql  = "INSERT INTO fin_conta (NOMEINTERNO, NOMECONTABANCO, BANCO, AGENCIA, CONTACORRENTE, ";
        $sql .= "CONTATO, DESCONTOBONIFICACAO, MULTA, JUROS, MSGBLOQUETO, PROTESTO) ";
        $sql .= "VALUES (";
        $sql .= "'" . $this->getNomeInterno() . "', ";
        $sql .= "'" . $this->getNomeContaBanco() . "', ";
        $sql .= "'" . $this->getBanco() . "', ";
        $sql .= $this->getAgencia() . ", ";
        $sql .= "'" . $this->getContaCorrente() . "', ";
        $sql .= "'" . $this->getContato() . "', ";
        $sql .= "'" . $this->getDescontoBonificacao('B') . "', ";
        $sql .= "'" . $this->getMulta('B') . "', ";
        $sql .= "'" . $this->getJuros('B') . "', ";
        $sql .= "'" . $this->getMsgBloqueto() . "', ";
        $sql .= "'" . $this->getProstesto() . "');";

        //echo $sql;
        $contaBanco = new c_banco;
        $contaBanco->exec_sql($sql);
        $contaBanco->close_connection();
        return $contaBanco->result;
    } // fim incluiBanco

    /**
     * @name alteraBanco
     * @description altera registro existente
     */
    public function alteraContaBanco(){

        if($this->getMsgBloqueto() !== '' and $this->getMsgBloqueto() !== null){
            $msgBloqueto = c_tools::limpaCaracteres($this->getMsgBloqueto());
        }

        $sql  = "UPDATE FIN_CONTA ";
        $sql .= "SET ";
        $sql .= "NOMEINTERNO = '" . $this->getNomeInterno() . "', ";
        $sql .= "NOMECONTABANCO  = '" . $this->getNomeContaBanco() . "', ";
        $sql .= "BANCO = '" . $this->getBanco() . "', ";
        $sql .= "AGENCIA = '" . $this->getAgencia() . "', ";
        $sql .= "CONTACORRENTE = '" . $this->getContaCorrente() . "', ";
        $sql .= "CONTATO = '" . $this->getContato() . "', ";
        $sql .= "DESCONTOBONIFICACAO = '" . $this->getDescontoBonificacao('B') . "', ";
        $sql .= "MULTA = '" . $this->getMulta('B') . "', ";
        $sql .= "JUROS = '" . $this->getJuros('B') . "', ";
        $sql .= "MSGBLOQUETO = '" . $msgBloqueto . "', ";
        $sql .= "PROTESTO = '" . $this->getProstesto() . "' ";
        $sql .= "WHERE CONTA = " . $this->getId() . ";";

        $contaBanco = new c_banco;
        $contaBanco->exec_sql_lower_case($sql);
        $contaBanco->close_connection();
        return $contaBanco->result;
    }  // fim alteraBanco

    /**
     * @name exlcuiBanco
     * @description esclui resgistro existe
     */
    public function excluiContaBanco()
    {

        $sql  = "DELETE FROM fin_conta ";
        $sql .= "WHERE conta = " . $this->getId();
        $contaBanco = new c_banco;
        $res_contaBanco =  $contaBanco->exec_sql($sql);
        $contaBanco->close_connection();

        if ($res_contaBanco > 0) :
            return '';
        else :
            return 'Os dados ' . $this->getNomeInterno() . ' não foram excluidos!';
        endif;
    }  // fim excluiBanco

}	//	END OF THE CLASS
