<?php

/****************************************************************************
*Cliente...........:
*Contratada........: ADMService
*Desenvolvedor.....: Marcio Sergio da Silva
*Sistema...........: Sistema de Informacao Gerencial
*Classe............: Index (Login)
*Ultima Atualizacao: 10/02/2016
****************************************************************************/
require_once("config.php");
require_once(ADMbib."/httpException.php");
require_once(ADMsmart."/libs/Smarty.class.php");

//    set_exception_handler('exception_handler');

//Class index
Class p_index {

public $usuario = NULL;
public $senha = NULL;
public $empresa = NULL;
public $userOk = false;
public $form = NULL;
public $modulo = NULL;
public $opcao = NULL;
public $parm = NULL;
public $e_submenu = NULL;
public $e_letra = NULL;
public $e_id = NULL;
public $dinamico = false;


//---------------------------------------------------------------
//---------------------------------------------------------------
function __construct(){
    @set_exception_handler(array($this, 'exception_handler'));
       
    //Assim obtém os dados passando pelo filtro contra INJECTION ( segurança PHP )
    $parmPost = filter_input_array(INPUT_POST, FILTER_DEFAULT);
    $parmGet = filter_input_array(INPUT_GET, FILTER_DEFAULT);
//    $parmSession = filter_input_array(INPUT_SESSION, FILTER_DEFAULT);
    
    session_cache_limiter('nocache');
//    ini_set( 'session.gc_maxlifetime', '30' );
//    ini_set ( 'session.cookie_time', '30') ;
    header('Access-Control-Allow-Origin: *');
    
    // Cria uma instancia variaveis de session
    session_start();
    // $_SESSION['user_array']= array_map(function($n) { return null; }, range(1, 20) );

    // inclui variaveis config e classes
    require_once(ADMbib."/c_database.php");
    require_once(ADMbib."/c_user.php");
    
    $this->session = new c_user();
    $this->session->from_array($_SESSION['user_array']);
//    c_user::from_array($_SESSION['user_array']);
//	
    // Cria uma instancia do Smarty
    $this->smarty = new Smarty;

    // caminhos absolutos para todos os diretorios do Smarty
    $this->smarty->template_dir = ADMraizCliente."/template/".$this->modulo;
    $this->smarty->compile_dir = ADMraizCliente."/smarty/templates_c/";
    $this->smarty->config_dir = ADMraizCliente."/smarty/configs/";
    $this->smarty->cache_dir = ADMraizCliente."/smarty/cache/";


    // metodo SET dos dados do FORM para o TABLE
    $this->usuario=(isset($parmPost['usuario']) ? $parmPost['usuario'] : '');
    $this->senha=(isset($parmPost['senha']) ? $parmPost['senha'] : '');
    $this->empresa=(isset($parmPost['empresa']) ? $parmPost['empresa'] : '');
    $this->e_submenu=(isset($parmPost['submenu']) ? $parmPost['submenu'] : '');
    $this->e_letra=(isset($parmPost['letra']) ? $parmPost['letra'] : '');
    $this->e_id=(isset($parmPost['id']) ? $parmPost['id'] : '');
    $this->modulo=(isset($parmGet['mod']) ? $parmGet['mod'] : (isset($parmPost['mod']) ? $parmPost['mod'] : ''));
    $this->form=(isset($parmGet['form']) ? $parmGet['form'] : (isset($parmPost['form']) ? $parmPost['form'] : ''));
    $this->opcao=(isset($parmGet['opcao']) ? $parmGet['opcao'] : (isset($parmPost['opcao']) ? $parmPost['opcao'] : ''));
    $this->parm=(isset($parmGet['parm']) ? $parmGet['parm'] : '');

    
    // caminhos absolutos para todos os diretorios biblioteca e sistema
    $this->smarty->assign('bootstrap', ADMbootstrap);
    
    

/*    $this->smarty->debugging = false;
    $this->smarty->caching = false;
    $this->smarty->cache_lifetime = 120;    
 * 
 */
}

public function exception_handler($e) {
    if (is_a($e, 'httpException')) {
        $e->header();
        $title = $e->getCode() . ' Error';
    } else {
        $title = get_class($e);
    }

    $this->smarty->template_dir = ADMraizFonte."/template/bib";

    $this->smarty->assign('date', date("d-m-Y H:i:s"));
    $this->smarty->assign('nomeUser', $_SESSION['user_array'][1]);
    $this->smarty->assign('codUser', $_SESSION['user_array'][0]);
    $this->smarty->assign('empresa', $this->m_empresanome);
    $this->smarty->assign('file', $e->getFile());
    $this->smarty->assign('line', $e->getLine());
    $this->smarty->assign('code', $e->getCode());
    $this->smarty->assign('mensagem', $e->getMessage());
    $this->smarty->assign('title', $title);
    $this->smarty->assign('trace', $e->getTrace());
    $this->smarty->assign('letra', $this->e_letra);
    $this->smarty->assign('submenu', $this->e_submenu);
    $this->smarty->assign('id', $this->e_id);
    $this->smarty->assign('modulo', $this->modulo);
    $this->smarty->assign('form', $this->form);
    $this->smarty->assign('opcao', $this->opcao);
    $this->smarty->assign('parm', $this->parm);
    
    $this->smarty->display('httpException.tpl');
    
}


//---------------------------------------------------------------
//---------------------------------------------------------------
function controle(){
    
    $parmPost = filter_input_array(INPUT_POST, FILTER_DEFAULT);
            
    if ($this->form == ""){
        if ($this->usuario <> ""){
            if ($this->empresa == "0"){
                $this->userOk = false;}
            else{
                $processo = new c_user();
                $processo->m_usernome = addslashes(strtoupper($parmPost['usuario']));
                $processo->m_usersenha = addslashes($parmPost['senha']);
                $processo->m_empresaid = $parmPost['empresa'];
                $this->userOk = $processo->verificaUsuario();}

                if ($this->userOk){
                    $processo->busca_dados();
                    $_SESSION['user_array'] = $processo->to_array();
                    $this->smarty->assign('NomeUser', $processo->m_usernome); // $_SESSION['user_array'][1]);
                    $this->smarty->assign('CodUser', $processo->m_userid); // $_SESSION['user_array'][0]);
                    $this->smarty->assign('Empresa', $processo->m_empresafantasia); // $_SESSION['user_array'][6]);
                    $this->desenhaMenu();
                }
                else {
                    $this->desenhaLogin("US&Aacute;URIO/SENHA INV&Aacute;LIDO");}
        }
        else {
                    $this->desenhaLogin();}
    }        
    else{
        switch ($this->opcao) {
            case 'pesquisar':
                $this->smarty->assign('NomeUser', $this->session->m_usernome); // $_SESSION['user_array'][1]);
                $this->smarty->assign('CodUser', $this->session->m_userid); // $_SESSION['user_array'][0]);
                $this->smarty->assign('opcao', $this->modulo);
                $this->smarty->display('header.tpl');
                include_once(ADMforms."/".$this->modulo."/p_".$this->form.".php");
                $this->smarty->display('menuclose.tpl');
                break;
            case 'cadastrar':
                $this->smarty->assign('NomeUser', $this->session->m_usernome); // $_SESSION['user_array'][1]);
                $this->smarty->assign('CodUser', $this->session->m_userid); // $_SESSION['user_array'][0]);
                $this->smarty->assign('Empresa', $this->session->m_empresafantasia); // $_SESSION['user_array'][6]);
                $this->smarty->display('header_print.tpl');
                include_once(ADMforms."/".$this->modulo."/p_".$this->form.".php");
                break;
            case 'imprimir':
                $this->smarty->assign('NomeUser', $this->session->m_usernome); // $_SESSION['user_array'][1]);
                $this->smarty->assign('CodUser', $this->session->m_userid); // $_SESSION['user_array'][0]);
                $this->smarty->assign('opcao', $this->modulo);
                $this->smarty->display('header_print.tpl');
                include_once(ADMforms."/".$this->modulo."/p_".$this->form.".php");
//                $this->smarty->display('menuclose.tpl');
                break;
            case 'blank':
                $this->smarty->assign('NomeUser', $this->session->m_usernome); // $_SESSION['user_array'][1]);
                $this->smarty->assign('CodUser', $this->session->m_userid); // $_SESSION['user_array'][0]);
                $this->smarty->assign('opcao', $this->modulo);
                include_once(ADMforms."/".$this->modulo."/p_".$this->form.".php");
                break;
            default:
                $this->smarty->assign('NomeUser', $this->session->m_usernome); // $_SESSION['user_array'][1]);
                $this->smarty->assign('CodUser', $this->session->m_userid); // $_SESSION['user_array'][0]);
                $this->smarty->assign('Empresa', $this->session->m_empresafantasia); // $_SESSION['user_array'][6]);
                $this->smarty->display('header.tpl');
                $this->smarty->display('menuopen.tpl');
                $class = "p_".$this->form;
                include_once(ADMforms."/".$this->modulo."/p_".$this->form.".php");
                switch ($this->form):
                    case 'pedido_venda_nf':
                        $class = "p_".$this->form;
                        $form = new $class();
                        $form->controle();
                endswitch;
/*                $class = "p_".$this->form;
                if (class_exists($class)):
                    $form = new $class();
                    $form->controle();
                endif;    */
                $this->smarty->display('menuclose.tpl');
        }

    }
  	
      

} // fim controle
//---------------------------------------------------------------
//---------------------------------------------------------------
function desenhaMenu($mensagem=NULL){

    $this->smarty->display('header.tpl');
    $this->smarty->display('menuopen.tpl');
    $this->smarty->display('dashboard.tpl');
    $this->smarty->display('form.inc');
    $this->smarty->display('menuclose.tpl');
    
}//fim desenhaCadastroBanco

//---------------------------------------------------------------
//---------------------------------------------------------------
function desenhaLogin($mensagem=NULL){

    
    // Empresa
    $consulta = new c_banco();
    if (!$consulta->resultado):
        $sql = "select empresa, nomeempresa from amb_empresa";
        $consulta->exec_sql($sql);
        $consulta->close_connection();
        $result = $consulta->resultado;
        $empresa_ids[0] = "0";
        $empresa_desc[0] = "Empresa";
        for ($i=0; $i < count($result); $i++){
            $empresa_ids[$i+1] = $result[$i]['EMPRESA'];
            $empresa_desc[$i+1] = $result[$i]['NOMEEMPRESA'];
        }
        $this->smarty->assign('empresa_ids', $empresa_ids);
        $this->smarty->assign('empresa_names', $empresa_desc);
        $this->smarty->assign('empresa_id', '');
    else:
        $mensagem = $consulta->resultado;
    endif;

    $this->smarty->assign('mensagem', $mensagem);
       
    $this->smarty->display('login.tpl');
    
}//fim desenhaCadastroBanco

//-------------------------------------------------------------
}	//	END OF THE CLASS

// Rotina principal - cria classe
$index = new p_index();

                                      
$index->controle();
 
  
?>
