<?php

/**
 * @package   astec
 * @name      p_nota_fiscal
 * @version   3.0.00
 * @copyright 2016
 * @link      http://www.admservice.com.br/
 * @author    Lucas tortola da Silva Bucko<lucas.tortola@admservice.com.br>
 * @date      12/04/2016
 */
// Evita que usuários acesse este arquivo diretamente
if (!defined('ADMpath')): exit;
endif;
$dir = dirname(__FILE__);
require_once($dir . "/../../../smarty/libs/Smarty.class.php");
require_once($dir . "/../../forms/est/p_nfephp_40.php");
require_once($dir . "/../../forms/est/p_nfephp_imprime_danfe.php");
require_once($dir . "/../../class/est/c_nota_fiscal.php");
require_once($dir . "/../../class/est/c_nota_fiscal_produto.php");
require_once($dir . "/../../class/ped/c_pedido_venda_nf.php");
require_once($dir . "/../../class/ped/c_pedido_venda.php");
require_once($dir . "/../../class/fin/c_lancamento.php");
require_once($dir . "/../../class/crm/c_conta.php");
require_once($dir . "/../../class/est/c_produto_estoque.php");
include_once($dir."/../../bib/c_date.php");

//Class P_Nota_Fiscal
Class p_nota_fiscal extends c_nota_fiscal {

    private $m_submenu = NULL;
    private $m_letra = NULL;
    private $m_opcao = NULL;
    private $m_msg = NULL;
    private $m_justificativa = NULL;
    private $m_inutModelo = NULL;
    private $m_inutSerie = NULL;
    private $m_inutNumIni = NULL;
    private $m_inutNumFim = NULL;
    private $m_inutJust = NULL;
    private $m_cartaC = NULL;
    private $m_notas_xml = NULL;
    private $m_email = NULL;
    
    public $smarty = NULL;

    
//---------------------------------------------------------------
//---------------------------------------------------------------
    function __construct() {

        //Assim obtém os dados passando pelo filtro contra INJECTION ( segurança PHP )
        $this->parmPost = filter_input_array(INPUT_POST, FILTER_DEFAULT);

        // Cria uma instancia variaveis de sessao
        session_start();
        c_user::from_array($_SESSION['user_array']);

        // Cria uma instancia do Smarty
        $this->smarty = new Smarty;

        // caminhos absolutos para todos os diretorios do Smarty
        $this->smarty->template_dir = ADMraizFonte . "/template/est";
        $this->smarty->compile_dir = ADMraizCliente . "/smarty/templates_c/";
        $this->smarty->config_dir = ADMraizCliente . "/smarty/configs/";
        $this->smarty->cache_dir = ADMraizCliente . "/smarty/cache/";
        
        // inicializa variaveis de controle
        $this->m_submenu = $this->parmPost['submenu'];
        $this->m_opcao = $this->parmPost['opcao'];
        $this->m_letra = $this->parmPost['letra'];
        $this->m_par = explode("|", $this->m_letra);
        $this->m_notas_xml = $this->parmPost['notas_xml'];
        $this->m_email = $this->parmPost['email'];
        
        // caminhos absolutos para todos os diretorios biblioteca e sistema
        $this->smarty->assign('pathJs',  ADMhttpBib.'/js');
        $this->smarty->assign('bootstrap', ADMbootstrap);
        $this->smarty->assign('raizCliente', $this->raizCliente);
        $this->smarty->assign('admClass', ADMclass);

        // metodo SET dos dados do FORM para o TABLE
        $this->setId(isset($this->parmPost['id']) ? $this->parmPost['id'] : "");
        $this->setModelo(isset($this->parmPost['modelo']) ? $this->parmPost['modelo'] : "55");
        $this->setSerie(isset($this->parmPost['serie']) ? $this->parmPost['serie'] : "");
        $this->setNumero(isset($this->parmPost['numero']) ? $this->parmPost['numero'] : "");
        $this->setPessoa(isset($this->parmPost['pessoa']) ? $this->parmPost['pessoa'] : "");
        $this->setEmissao(isset($this->parmPost['emissao']) ? $this->parmPost['emissao'] : date("Y/m/d H:i"));
        $this->setIdNatop(isset($this->parmPost['idNatOp']) ? $this->parmPost['idNatOp'] : "");
        $this->setTipo(isset($this->parmPost['tipo']) ? $this->parmPost['tipo'] : "");
        $this->setContrato(isset($this->parmPost['contrato']) ? $this->parmPost['contrato'] : "");
        $this->setSituacao(isset($this->parmPost['situacao']) ? $this->parmPost['situacao'] : "A");
        $this->setFormaPgto(isset($this->parmPost['formaPgto']) ? $this->parmPost['formaPgto'] : "");
        $this->setCondPgto(isset($this->parmPost['condPgto']) ? $this->parmPost['condPgto'] : "");
        $this->setDataSaidaEntrada(isset($this->parmPost['dataSaidaEntrada']) ? $this->parmPost['dataSaidaEntrada'] : date("Y/m/d H:i"));
        $this->setFormaEmissao(isset($this->parmPost['formaEmissao']) ? $this->parmPost['formaEmissao'] : "");
        $this->setFinalidadeEmissao(isset($this->parmPost['finalidadeEmissao']) ? $this->parmPost['finalidadeEmissao'] : "");
        $this->setNfeReferenciada(isset($this->parmPost['nfeReferenciada']) ? $this->parmPost['nfeReferenciada'] : "");
        $this->setCentroCusto(isset($this->parmPost['centroCusto']) ? $this->parmPost['centroCusto'] : "");
        $this->setGenero(isset($this->parmPost['genero']) ? $this->parmPost['genero'] : "");
        $this->setTotalnf(isset($this->parmPost['totalnf']) ? $this->parmPost['totalnf'] : "");
        $this->setObs(isset($this->parmPost['obs']) ? $this->parmPost['obs'] : "");
        $this->setModFrete(isset($this->parmPost['modFrete']) ? $this->parmPost['modFrete'] : "");
        $this->setTransportador(isset($this->parmPost['transportador']) ? $this->parmPost['transportador'] : "0");
        $this->setPlacaVeiculo(isset($this->parmPost['placaVeiculo']) ? $this->parmPost['placaVeiculo'] : "");
        $this->setVolume(isset($this->parmPost['volume']) ? $this->parmPost['volume'] : "1");
        $this->setVolEspecie(isset($this->parmPost['volEspecie']) ? $this->parmPost['volEspecie'] : "");
        $this->setVolMarca(isset($this->parmPost['volMarca']) ? $this->parmPost['volMarca'] : "");
        $this->setVolPesoLiq(isset($this->parmPost['volPesoLiq']) ? $this->parmPost['volPesoLiq'] : "");
        $this->setVolPesoBruto(isset($this->parmPost['volPesoBruto']) ? $this->parmPost['volPesoBruto'] : "");
        $this->setFrete(isset($this->parmPost['frete']) ? $this->parmPost['frete'] : "0,00");
        $this->setDespAcessorias(isset($this->parmPost['despacessorias']) ? $this->parmPost['despacessorias'] : "0,00");
        $this->setSeguro(isset($this->parmPost['seguro']) ? $this->parmPost['seguro'] : "0,00");
        $this->m_justificativa =isset($this->parmPost['justificativa']) ? $this->parmPost['justificativa'] : "";
        $this->m_inutModelo =isset($this->parmPost['inutModelo']) ? $this->parmPost['inutModelo'] : "";
        $this->m_inutSerie =isset($this->parmPost['inutSerie']) ? $this->parmPost['inutSerie'] : "";
        $this->m_inutNumIni =isset($this->parmPost['inutNumIni']) ? $this->parmPost['inutNumIni'] : "";
        $this->m_inutNumFim =isset($this->parmPost['inutNumFim']) ? $this->parmPost['inutNumFim'] : "";
        $this->m_inutJust =isset($this->parmPost['inutJustificativa']) ? $this->parmPost['inutJustificativa'] : "";
        $this->m_cartaC =isset($this->parmPost['carta']) ? $this->parmPost['carta'] : "";
        
        // dados para exportacao e relatorios
        $this->smarty->assign('titulo', "Nota Fiscal");
        $this->smarty->assign('colVis', "[ 0,1,2,3,4,5,6,7,8,9,10, 11 ]"); 
        $this->smarty->assign('disableSort', "[ 11 ]"); 
        $this->smarty->assign('numLine', "25"); 
                
        // include do javascript
//        include ADMjs . "/est/s_nota_fiscal.js";
    }

//---------------------------------------------------------------
//---------------------------------------------------------------
    function controle() {
        switch ($this->m_submenu) {
            case 'cadastrar':
                if ($this->verificaDireitoUsuario('EstNotaFiscal', 'I')) {
                    $parametros = new c_banco;
                    $sql = "SELECT * FROM EST_PARAMETRO ";
                    $sql .= "WHERE (FILIAL = ".$this->m_empresacentrocusto.") AND (MODELO=55)";
                    $banco = new c_banco;
                    $res_parametro = $banco->exec_sql($sql);
                    $parametros->close_connection();
                    if (!is_array($res_parametro)):
                        $result = false;
                        throw new Exception( "Parametros não cadastrado!! - FILIAL = ".$this->m_empresacentrocusto );
                    endif;
                    $this->setNatOperacao($res_parametro[0]['NATOPERACAO']);
                    $this->setGenero($res_parametro[0]['GENERO']);
                    $this->setSerie($res_parametro[0]['SERIE']);
                    $parametros->close_connection();    
                    $this->setTipo('1'); // padrão saída

                    $parametros = new c_banco;
                    $parametros->setTab("EST_PARAMETRO");
                    $cCusto = $parametros->getField("CENTROCUSTO", "FILIAL=".$this->m_empresacentrocusto);
                    $parametros->close_connection();

                    $this->setCentroCusto($cCusto);
                    
                    $this->desenhaCadastroNotaFiscal();
                }
                break;
            case 'alterar':
                if ($this->verificaDireitoUsuario('EstNotaFiscal', 'A')) {
                    $this->setNotaFiscal();
                    $this->desenhaCadastroNotaFiscal();
                }
                break;
            
            case 'inclui':
                if ($this->verificaDireitoUsuario('EstNotaFiscal', 'I')) {
                    // ****** Gerar numero da notafiscal!! *********
                    //$numNf = $this->geraNumNf($this->getModelo(), $this->getSerie());
                    $numNf = 0;
                    $this->setOrigem('NFE');
                    $this->setDoc($numNf);
                    $this->setNumero($numNf);
                    /*$this->m_msg = "Numero NF >>>".$numNf;
                    if (intval($numNf)==0):
                        $result = false;
                        throw new Exception( $this->m_msg );
                    endif;
                    if ($this->existeNotaFiscal()) {
                        $this->m_submenu = "cadastrar";
                        $this->desenhaCadastroNotaFiscal($this->m_msg." Nota Fiscal já existe, altere o numero da NF ou Cliente",'alerta');
                    } else {*/
                        $this->getNatOperacao();//====
                        $this->m_msg = $this->incluiNotaFiscal();
                        if (is_numeric($this->m_msg))
                            $this->mostraNotaFiscal(' Nota fiscal Identificador >>> '.$this->getId().' Cadastrado.','sucesso');
                        else
                            $this->mostraNotaFiscal($this->m_msg,'');
                    
                }
                break;
            case 'altera':
                if ($this->verificaDireitoUsuario('EstNotaFiscal', 'A')) {
                    try {
                        $msg == '';
                        $tipoMsg = 'sucesso';
                        if ($this->existeNotaFiscalBaixa($this->getId())){// verificar si a nota esta baixada
                            $this->mostraNotaFiscal('Nota fiscal foi Baixada, n&atilde;o sendo possivel alterar.','alerta');
                        }else{
                            $result = $this->alteraNotaFiscal();
                            if(!$result):
                                throw new Exception( "Nota ".$this->getNumero()." não cadastrado " );
                            endif;
                        }
                    } catch (Exception $e) {
                        $tipoMsg = 'alerta';
                        $msg = $e->getMessage();
                    }finally {
                        if ($msg == ''):
                            $this->mostraNotaFiscal();
                        else:
                            $this->desenhaCadastroNotaFiscal($msg, $tipoMsg);
                        endif;
                    }
                    
                    
                }
                break;
            case 'exclui':
                if ($this->verificaDireitoUsuario('EstNotaFiscal', 'E')) {
                    if ($this->existeNotaFiscalBaixa($this->getId())){// verificar si a nota esta baixada
                        $this->mostraNotaFiscal('Nota fiscal foi recebida, n&atilde;o sendo possivel excluir.','alerta');
                    }else{
                        if ($this->existeNotaFiscalProduto($this->getId())){
                            $this->mostraNotaFiscal('Existem Produtos na NF, Exclua os produtos antes de deletar a NF.', 'alerta');
                        }else{
                            $this->excluiNotafiscal();
                            $this->mostraNotaFiscal('Nota fiscal excluida.','sucesso');
                        }
                        
                    }
                }
                break;
            case 'geraXML':
                    // Gera e altera numero NF
                    $this->setNotaFiscal();
                    if ($this->getNumero() == 0):
                        $numNf = $this->geraNumNf($this->getModelo(), $this->getSerie(), $this->getCentroCusto());
                        if (intval($numNf)==0):
                            $this->m_msg = "Idendificador NF >>> ".$idGerado." - Número não Gerado";
                            $result = false;
                            throw new Exception( $this->m_msg);
                        endif;
                        $this->setNumero($numNf);
                        $this->alteraNfNumero();
                    endif;
                        
                    // valida e autoriza nf
                    $exporta = new p_nfe_40();
                    $result = $exporta->Gera_XML($this->getId(), $this->m_empresacentrocusto, $this->getTipo());
                    
                    //$msg='';
                    //$this->desenhaPrintDanfe($msg, null, $result);

                    $printDanfe = new p_nfephp_imprime_danfe();
                    $printDanfe->printDanfe($this->getId(), '', '', '', '', 'nota_fiscal');

                break;
            case 'emailDANFE':
                    $this->setNotaFiscal();
                    $danfe = new p_nfe_40();
                    $conta = new c_conta;
                    $conta->setId($this->getPessoa());
                    $arrConta = $conta->select_conta();
                    
                    // busca emitente
                    $emitente = new c_banco;
                    $emitente->setTab('AMB_EMPRESA');
                    $arrEmitente = $emitente->getRecord('centrocusto= '.$this->getCentroCusto());
                    $emitente->close_connection();
                    $msg = $danfe->enviaEmailDANFE($this->getModelo(), $arrConta[0]['EMAILNFE'], $arrConta[0]['EMAIL'],$this->getChNfe(),
                    $this->getEmissao('F'), $this->getNumero(), $this->getSerie(), $arrEmitente[0]['NOMEEMPRESA']);
                    $this->mostraNotaFiscal($msg,'sucesso');
                break;
            case 'geraDANFE':
                    $this->setNotaFiscal();
                    $danfe = new p_nfe_40();
                    $msg = $danfe->gera_DANFE($this->getChNfe());
                    $this->mostraNotaFiscal($msg.$this->getNumero(),'sucesso');
                break;
            case 'cancelaNFE':
                    if ($this->verificaDireitoUsuario('EstNotaFiscal', 'S')):
                        $this->setNotaFiscal();
                        if ($this->getSituacao() == 'B'):
                            if (!(c_lancamento::verificaDocBaixado($this->getPessoa(), $this->getNumero(), 'NFS'))):
                                $danfe = new p_nfe_40();
                                $msg = $danfe->cancela_NFE($this->getChNfe(), $this->getNProt(), $this->m_justificativa, $this->getModelo());
                                $cStat = $msg->retEvento->infEvento->cStat;
                                if (($msg->cStat == '128') and (($cStat == '101' || $cStat == '135' || $cStat == '155' ))):
                                    $this->alteraSituacao('C');
                                    c_lancamento::alteraSituacaoFinanceiro($this->getPessoa(), $this->getNumero(), 'NFS', 'C');
                                    $this->incluiNfEvento($msg, 'C', '1', $this->getNumero(), $this->getNumero(), $this->m_justificativa);
                                    // altera situação pedido
                                    $origem = $this->getOrigem();
                                    if ($this->getOrigem() == 'PED'):
                                        $objPedido = new c_pedidoVenda();
                                        $objPedido->setId($this->getDoc());
                                        $objPedido->setSituacao(3);
                                        $objPedido->alteraPedidoSituacao();
                                    endif;
                                    
                                    // estorna produto
                                    $objNfProduto = new c_nota_fiscal_produto();
                                    $objNfProduto->setIdNf($this->getId());
                                    $arrNfProduto = $objNfProduto->select_nota_fiscal_produto_nf();
                                    for ($i = 0; $i < count($arrNfProduto); $i++) {
                                        c_produto_estoque::produtoBaixaEstorna($this->m_empresacentrocusto, 'NFS',  $this->getId(), $arrNfProduto[$i]['CODPRODUTO'], $arrNfProduto[$i]['QUANT'] );

                                    } //for                             
                                    
                                    
                                    $this->mostraNotaFiscal('Cancelamento Nfe: '.$this->getNumero(). ' - Realizado com sucesso','sucesso');
                                else:    
                                    $this->mostraNotaFiscal($msg->retEvento->infEvento->cStat.' - '.$msg->retEvento->infEvento->xMotivo.' NFe:'.$this->getNumero(),'erro');
                                endif;
                            else:    
                                $this->mostraNotaFiscal('Documento financeiro já baixo, <br>realize o estorno antes do CANCELAMENTO da NFe: '.$this->getNumero(),'erro');
                            endif;
                        else:
                            $this->mostraNotaFiscal('Nota Fiscal Eletrônica não autorizada, <br>impossibilitando o CANCELAMENTO da NFe: '.$this->getNumero(),'erro');
                            
                        endif;        
                    endif;

                break;
            case 'cartaCNFE':
                    if ($this->verificaDireitoUsuario('EstNotaFiscal', 'S')):
                        $this->setNotaFiscal();
                        if ($this->getSituacao() == 'B') {
                                $seqEvento = $this->geraNumEvento($this->getModelo(), $this->getSerie(), $this->getNumero(), $this->getCentroCusto(), "T");
                                $danfe = new p_nfe_40();
                                $msg = $danfe->carta_correcao_NFE($this->getChNfe(), $this->getNProt(), $this->m_cartaC, $this->getModelo(), $seqEvento);
                                //if (($msg['cStat'] == '128') and ($msg['evento'][0]['cStat'] == '135')):
                                    $this->incluiNfEvento($msg, 'T', $seqEvento, $this->getNumero(), $this->getNumero(), $this->m_cartaC);                                
                                    // busca emitente
                                    $emitente = new c_banco;
                                    $emitente->setTab('AMB_EMPRESA');
                                    $arrEmitente = $emitente->getRecord('centrocusto= '.$this->getCentroCusto());
                                    $emitente->close_connection();
                                
                                    // visualizar 
                                     $arq = '';
                                     $aEnd = array(
                                        'razao' => $arrEmitente[0]['NOMEEMPRESA'],
                                        'logradouro' => $arrEmitente[0]['TIPOEND'].' '.$arrEmitente[0]['ENDERECO'],
                                        'numero' => $arrEmitente[0]['NUMERO'],
                                        'complemento' => $arrEmitente[0]['COMPLEMENTO'],
                                        'bairro' => $arrEmitente[0]['BAIRRO'],
                                        'CEP' => $arrEmitente[0]['CEP'],
                                        'municipio' => $arrEmitente[0]['CIDADE'],
                                        'UF' => $arrEmitente[0]['UF'],
                                        'telefone' => '('.$arrEmitente[0]['FONEAREA'].') '.$arrEmitente[0]['FONENUM'],
                                        'email' => $arrEmitente[0]['EMAIL'] 
                                    );
                                
                                    $danfe->visualizar_carta_correcao_NFE($this->getChNfe(), $this->getNProt(), $seqEvento, date('Ym'), $aEnd, $arq);
                                    $this->mostraNotaFiscal('Carta Correção Nfe: '.$this->getNumero(). ' realizado com sucesso','sucesso', $arq);
                        }
                        else
                            $this->mostraNotaFiscal('Nota Fiscal Eletrônica não autorizada, <br>impossibilitando o CANCELAMENTO da NFe: '.$this->getNumero(),'erro');        
                    endif;

                break;
            case 'inutilizaNFE':
                    $danfe = new p_nfe_40();
                    $msg = $danfe->inutiliza_NFE($this->m_inutModelo, $this->m_inutSerie, $this->m_inutNumIni, $this->m_inutNumFim, $this->m_inutJust);
                    $cStat = $msg->infInut->cStat;
                    $xMotivo = $msg->infInut->xMotivo;
                    if ($cStat == '102'):
                        $this->salvaJustificativa($xMotivo, $this->m_inutModelo, $this->m_inutSerie, $this->m_inutNumIni, $this->m_inutNumFim, $this->m_inutJust);
                        $this->mostraNotaFiscal($xMotivo . ' : ' .$this->m_inutNumIni.' - '. $this->m_inutNumFim,'sucesso');
                    else:    
                        $this->mostraNotaFiscal($xMotivo,'erro');
                    endif;
                break;
/*            case 'inutilizaNFE':
                    $danfe = new p_nfe_40();
                    $msg = $danfe->inutiliza_NFE($this->m_inutModelo, $this->m_inutSerie, $this->m_inutNumIni, $this->m_inutNumFim, $this->m_inutJust);
                    if ($msg['cStat'] == '102'):
                        $this->salvaJustificativa($msg, $this->m_inutModelo, $this->m_inutSerie, $this->m_inutNumIni, $this->m_inutNumFim, $this->m_inutJust);
                        $this->mostraNotaFiscal($msg['xMotivo'] . ' : ' .$this->m_inutNumIni.' - '. $this->m_inutNumFim,'sucesso');
                    else:    
                        $this->mostraNotaFiscal($msg['xMotivo'],'erro');
                    endif;
                break;
            case 'cadastrarProdutos':
                $this->desenhaCadastroNotaFiscalProduto();
                break;
            case 'alterarProdutos':
                if ($this->verificaDireitoUsuario('EstNotaFiscal', 'A')) {
                    $this->setNotaFiscal();
                    $this->desenhaCadastroNotaFiscal();
                }
                break;*/
            case 'danfe':
                if ($this->verificaDireitoUsuario('EstNotaFiscal', 'A')) {
                    $printDanfe = new p_nfephp_imprime_danfe();
                    $printDanfe->printDanfe($this->getId(), '', '', '', '', 'nota_fiscal');
                    //$this->setNotaFiscal();
                    //$this->desenhaCadastroNotaFiscal();
                }
                break;
            case 'calculoTributos':
                if ($this->verificaDireitoUsuario('EstNotaFiscal', 'A')) {
                try {
                    $this->setNotaFiscal();
                    $objNfProduto = new c_nota_fiscal_produto();
                    $objNfProduto->setIdNf($this->getId());
                    $arrNfProduto = $objNfProduto->select_nota_fiscal_produto_nf();
                    for ($i = 0; $i < count($arrNfProduto); $i++) {
                        $objNfProduto->setId($arrNfProduto[$i]['ID']);
                        $objNfProduto->setNotaFiscalProduto();
                        $objNfProduto->setQuant($objNfProduto->getQuant(), true);
                        $objNfProduto->setUnitario($objNfProduto->getUnitario(), true);
                        $objNfProduto->setDesconto($objNfProduto->getDesconto(), true); // VERIFICAR DESCONTO
                        $objNfProduto->setTotal($objNfProduto->getTotal(), true);

                        $c_pedidoVendaNf = new c_pedidoVendaNf();
                        
                        /*
                        $result = $c_pedidoVendaNf->calculaImpostosNfe($objNfProduto, 
                            $this->getIdNatop(), 
                            $this->getUfPessoa(), 
                            $this->getTipoPessoa(),
                            $this->getCentroCusto(),
                            $this->getPessoa()); 

                            */

                        $result = c_pedidoVendaNf::calculaImpostosNfe($objNfProduto, 
                                      $this->getIdNatop(), 
                                      $this->getUfPessoa(), 
                                      $this->getTipoPessoa(),
                                      $this->m_empresacentrocusto); 
                        

                        if (!$result):
                            $msg = "Tributos não localizado ".$objNfProduto->getDescricao()." Nat. Operação:".$this->getIdNatop().
                                " UF:".$this->getUfPessoa()." Tipo:".$this->getTipoPessoa().
                                " CST:".$objNfProduto->getOrigem().$objNfProduto->getTribIcms().
                                " NCM:".$objNfProduto->getNcm()." CEST:".$objNfProduto->getCest();
                            throw new Exception( $this->m_msg );
                        endif;

                        $result = $objNfProduto->alteraNotaFiscalProduto();
                        // verificar inclusao item
                        if (is_string($result)):
                            $msg = $result;
                            $result = false;
                            throw new Exception( $msg );
                        endif;

                    } //for
                    $this->desenhaCadastroNotaFiscal($msg);
                } catch (Error $e) {
                    throw new Exception($e->getMessage()."Alteração não realizada - Nf " );

                }catch (Exception $e) {
                    $this->desenhaCadastroNotaFiscal($msg, "alerta");
                    break;
                }
                    
                }
                break;
            case 'gerarXMLsContabilidade':{
                    $path = BASE_DIR_NFE_AMB;
                    $slash = '/'; 
                    $anomes = date('Ym');
                    $email = explode("|", $this->m_email);            
                    $notasXML = $this->select_nota_fiscal_letra($this->m_letra);
                    if($notasXML !== null){
                        $NotaFiscal = new p_nota_fiscal();  
                        $time = round(microtime(true) * 1000);
                        if (!file_exists($path.$slash.'enviadas'.$slash.'temporarias'.$slash.$anomes.$slash.$time.$slash)) {
                          mkdir($path.$slash.'enviadas'.$slash.'temporarias'.$slash.$anomes.$slash.$time.$slash, 0700, true);}           
                        for ($i=0;$i<count($notasXML);$i++){
                            $this->setId($notasXML[$i]["ID"]);
                            $emissao = explode("-", substr($notasXML[$i]["EMISSAO"],0,-11));
                            $checkFile = $path.$slash.'enviadas'.$slash.'aprovadas'.$slash.$emissao[0].$emissao[1].$slash.$notasXML[$i]["CHNFE"].'-nfe.xml';
                            if (!file_exists($checkFile)) {
                                $this->setNotaFiscal();
                                $exporta = new p_nfe_40();                        
                                $File = $exporta->Gera_XML($this->getId(), $this->getCentroCusto(), $this->getTipo(), null, $time); 
                            } else {
                                $File = $path.$slash.'enviadas'.$slash.'temporarias'.$slash.$anomes.$slash.$time.$slash; 
                                $copyFile = $File.$notasXML[$i]["CHNFE"].'.xml';
                                Copy($checkFile,$copyFile);                            
                            }                            
                        }
                    
                        $File = $this-> comprimir($File);
                        
                        $par = explode("|", $this-> m_letra);
                        $dataIni = $par[3];
                        $dataFim = $par[4];
                        if($this -> enviarEmailXML($email[0],$email[1],$email[2], null, $dataIni, $dataFim, $File)){ //se o envio ocorrer tiver sucesso
                            $this->mostraNotaFiscal('E-mail enviado com sucesso!', 'sucesso');
                        }else{
                            $this->mostraNotaFiscal('Ocorreu um erro no envio do e-mail', 'erro');
                        }
                    }else{
                        $this->mostraNotaFiscal("Xml's não localizados!"); 
                    }
                }
                break;
            default:
                if ($this->verificaDireitoUsuario('EstNotaFiscal', 'C')) {
                    $this->mostraNotaFiscal('');
                }
        }
    }
    /*
     * NOTA FISCAL PRODUTO
     */
        
    function desenhaPrintDanfe($mensagem = NULL,$tipoMsg=NULL, $result=null) {

        $id = $this->getId();
        $numPedido = $this->getDoc();
        $numNf = $this->getNumero();
        $this->smarty->assign('id', $id);
        $this->smarty->assign('danfe', $result['cDanfe']);
        $this->smarty->assign('pathCliente', ADMhttpCliente);


        $this->smarty->assign('numPedido', $numPedido);
        $this->smarty->assign('numNf', $numNf);
        //$this->smarty->assign('retorno', $retorno);
                
        
        $this->smarty->display('nota_fiscal_mostra_danfe.tpl');
        
    }
    
//---------------------------------------------------------------
//---------------------------------------------------------------
    function desenhaCadastroNotaFiscal($mensagem = NULL, $tipoMsg = NULL) {

        $this->smarty->assign('pathImagem', $this->img);
        $this->smarty->assign('pathCliente', ADMhttpCliente);
        $this->smarty->assign('subMenu', $this->m_submenu);
        $this->smarty->assign('opcao', $this->m_opcao);
        $this->smarty->assign('letra', $this->m_letra);
        $this->smarty->assign('mensagem', $mensagem);
        $this->smarty->assign('tipoMsg', $tipoMsg);

        $this->smarty->assign('id', $this->getId());
        $this->smarty->assign('modelo', $this->getModelo());
        $this->smarty->assign('serie', $this->getSerie());
        $this->smarty->assign('numero', $this->getNumero());
        $this->smarty->assign('pessoa', $this->getPessoa());
        $this->setNomePessoa();
        $this->smarty->assign('nome', $this->getNomePessoa());
        $this->smarty->assign('emissao', "'" . $this->getEmissao('F') . "'");
        $this->smarty->assign('idNatop', $this->getIdNatop());
        $this->smarty->assign('natOperacao', "'" . $this->getNatOperacao() . "'");
        $this->smarty->assign('nfeReferenciada', "'" . $this->getNfeReferenciada() . "'");

        $this->smarty->assign('dataSaidaEntrada', "'" . $this->getDataSaidaEntrada('F') . "'");
        $this->smarty->assign('totalnf', $this->getTotalnf('F'));
        $this->smarty->assign('obs', $this->getObs());

        $this->smarty->assign('transportador', $this->getTransportador());
        $this->setNomeTransportador();
        $this->smarty->assign('transpNome', $this->getNomeTransportador());
        $this->smarty->assign('placaVeiculo', $this->getPlacaVeiculo());
        $this->smarty->assign('volume', $this->getVolume());
        $this->smarty->assign('volumeEspecie', $this->getVolEspecie());
        $this->smarty->assign('volMarca', $this->getVolMarca());
        $this->smarty->assign('volPesoLiq', $this->getVolPesoLiq());
        $this->smarty->assign('volPesoBruto', $this->getVolPesoBruto());

        // ########## NATUREZA OPERACAO ##########
        $consulta = new c_banco();
        $sql = "select id, natoperacao as descricao from est_nat_op order by natoperacao";
        $consulta->exec_sql($sql);
        $consulta->close_connection();
        $result = $consulta->resultado;
        for ($i = 0; $i < count($result); $i++) {
            $natOperacao_ids[$i] = $result[$i]['ID'];
            $natOperacao_names[$i] = $result[$i]['DESCRICAO'];
        }
        $this->smarty->assign('natOperacao_ids', $natOperacao_ids);
        $this->smarty->assign('natOperacao_names', $natOperacao_names);
        $this->smarty->assign('natOperacao_id', $this->getIdNatop());

        // COMBOBOX CONDICAO PAGAMENTO
        $consulta = new c_banco();
        $sql = "SELECT * FROM fat_cond_pgto order by descricao;";
        $consulta->exec_sql($sql);
        $consulta->close_connection();
        $result = $consulta->resultado;
        for ($i = 0; $i < count($result); $i++) {
//            if ($this->getCondPg()==$result[$i]['ID']):
//                $descCondPgto = $result[$i]['DESCRICAO'];
//            endif;
            $condPgto_ids[$i] = $result[$i]['ID'];
            $condPgto_names[$i] = $result[$i]['DESCRICAO'];
        }
//        $this->smarty->assign('descCondPgto', "$descCondPgto");
        $this->smarty->assign('condPgto_ids', $condPgto_ids);
        $this->smarty->assign('condPgto_names', $condPgto_names);
        //$this->smarty->assign('condPgto_id', '');
        $this->smarty->assign('condPgto_id', $this->getCondPgto());

        
        // filial
        $consulta = new c_banco();
        $sql = "select centrocusto as id, descricao from fin_centro_custo where (ativo='S')";
        $consulta->exec_sql($sql);
        $consulta->close_connection();
        $result = $consulta->resultado;
        for ($i = 0; $i < count($result); $i++) {
            $filial_ids[$i] = $result[$i]['ID'];
            $filial_names[$i] = $result[$i]['DESCRICAO'];
        }
        $this->smarty->assign('filial_ids', $filial_ids);
        $this->smarty->assign('filial_names', $filial_names);
        $this->smarty->assign('filial_id', $this->getCentroCusto());

        // tipo
        $consulta = new c_banco();
        $sql = "select tipo as id, padrao as descricao from amb_ddm where (alias='EST_MENU') and (campo='TipoNotaFiscal')";
        $consulta->exec_sql($sql);
        $consulta->close_connection();
        $result = $consulta->resultado;
        $tipo_ids[0] = '';
        $tipo_names[0] = 'Selecione';
        for ($i = 0; $i < count($result); $i++) {
            $tipo_ids[$i+1] = $result[$i]['ID'];
            $tipo_names[$i+1] = $result[$i]['DESCRICAO'];
        }
        $this->smarty->assign('tipo_ids', $tipo_ids);
        $this->smarty->assign('tipo_names', $tipo_names);
        $this->smarty->assign('tipo_id', $this->getTipo());


        //situacao
        $consulta = new c_banco();
        $sql = "select tipo as id, padrao as descricao from amb_ddm where (alias='EST_MENU') and (campo='SituacaoNota')";
        $consulta->exec_sql($sql);
        $consulta->close_connection();
        $result = $consulta->resultado;
        for ($i = 0; $i < count($result); $i++) {
            $situacao_ids[$i] = $result[$i]['ID'];
            $situacao_names[$i] = $result[$i]['DESCRICAO'];
        }
        $this->smarty->assign('situacao_ids', $situacao_ids);
        $this->smarty->assign('situacao_names', $situacao_names);
        $this->smarty->assign('situacao_id', $this->getsituacao());
        
        // ########## PROJETO ##########
        $consulta = new c_banco();
        $sql = "select nrcontrato as id, descricao from cat_contrato where situacao = 'a' order by descricao; ";
        $consulta->exec_sql($sql);
        $consulta->close_connection();
        $result = $consulta->resultado;
        for ($i = 0; $i < count($result); $i++) {
            $contrato_ids[$i] = $result[$i]['ID'];
            $contrato_names[$i] =  $result[$i]['DESCRICAO'];
        }
        $this->smarty->assign('contrato_ids', $contrato_ids);
        $this->smarty->assign('contrato_names', $contrato_names);
        $this->smarty->assign('contrato_id', $this->getContrato());
        $this->smarty->assign('projeto', count($result));

        // genero documento
        $consulta = new c_banco();
        $sql = "select genero as id, descricao from fin_genero order by descricao";
        $consulta->exec_sql($sql);
        $consulta->close_connection();
        $result = $consulta->resultado;
        for ($i = 0; $i < count($result); $i++) {
            $generoDocto_ids[$i] = $result[$i]['ID'];
            $generoDocto_names[$i] = $result[$i]['ID'] . " - " . $result[$i]['DESCRICAO'];
        }
        $this->smarty->assign('generoDocto_ids', $generoDocto_ids);
        $this->smarty->assign('generoDocto_names', $generoDocto_names);
        $this->smarty->assign('generoDocto_id', $this->getGenero());

        // forma pagamento
        $consulta = new c_banco();
        $sql = "select tipo as id, padrao as descricao from amb_ddm where (alias='EST_MENU') and (campo='FormaPagamento')";
        $consulta->exec_sql($sql);
        $consulta->close_connection();
        $result = $consulta->resultado;
        for ($i = 0; $i < count($result); $i++) {
            $formaPagamento_ids[$i] = $result[$i]['ID'];
            $formaPagamento_names[$i] = $result[$i]['DESCRICAO'];
        }
        $this->smarty->assign('formaPagamento_ids', $formaPagamento_ids);
        $this->smarty->assign('formaPagamento_names', $formaPagamento_names);
        $this->smarty->assign('formaPagamento_id', $this->getFormaPgto());

        // forma emissao
        $consulta = new c_banco();
        $sql = "select tipo as id, padrao as descricao from amb_ddm where (alias='EST_MENU') and (campo='FormaEmissao')";
        $consulta->exec_sql($sql);
        $consulta->close_connection();
        $result = $consulta->resultado;
        for ($i = 0; $i < count($result); $i++) {
            $formaEmissao_ids[$i] = $result[$i]['ID'];
            $formaEmissao_names[$i] = $result[$i]['DESCRICAO'];
        }
        $this->smarty->assign('formaEmissao_ids', $formaEmissao_ids);
        $this->smarty->assign('formaEmissao_names', $formaEmissao_names);
        $this->smarty->assign('formaEmissao_id', $this->getFormaEmissao());


        // finalidade emissao
        $consulta = new c_banco();
        $sql = "select tipo as id, padrao as descricao from amb_ddm where (alias='EST_MENU') and (campo='FinalidadeEmissao')";
        $consulta->exec_sql($sql);
        $consulta->close_connection();
        $result = $consulta->resultado;
        for ($i = 0; $i < count($result); $i++) {
            $finalidadeEmissao_ids[$i] = $result[$i]['ID'];
            $finalidadeEmissao_names[$i] = $result[$i]['DESCRICAO'];
        }
        $this->smarty->assign('finalidadeEmissao_ids', $finalidadeEmissao_ids);
        $this->smarty->assign('finalidadeEmissao_names', $finalidadeEmissao_names);
        $this->smarty->assign('finalidadeEmissao_id', $this->getFinalidadeEmissao());

        // modalidade frete
        $consulta = new c_banco();
        $sql = "select tipo as id, padrao as descricao from amb_ddm where (alias='EST_MENU') and (campo='modFrete')";
        $consulta->exec_sql($sql);
        $consulta->close_connection();
        $result = $consulta->resultado;
        for ($i=0; $i < count($result); $i++){
                $modFrete_ids[$i] = $result[$i]['ID'];
                $modFrete_names[$i] = ucwords(strtolower($result[$i]['DESCRICAO']));
        }
        $this->smarty->assign('modFrete_ids', $modFrete_ids);
        $this->smarty->assign('modFrete_names', $modFrete_names);
        $this->smarty->assign('modFrete_id', $this->modFrete);

        // ########## CENTROCUSTO ##########
        $consulta = new c_banco();
        $sql = "select centrocusto as id, descricao from fin_centro_custo order by centrocusto";
        $consulta->exec_sql($sql);
        $consulta->close_connection();
        $result = $consulta->resultado;
        for ($i = 0; $i < count($result); $i++) {
            $centroCusto_ids[$i] = $result[$i]['ID'];
            $centroCusto_names[$i] = $result[$i]['ID'] . " - " . $result[$i]['DESCRICAO'];
        }
        $this->smarty->assign('centroCusto_ids', $centroCusto_ids);
        $this->smarty->assign('centroCusto_names', $centroCusto_names);        
        $this->smarty->assign('centroCusto_id', $this->getCentroCusto());  

        $this->smarty->assign('frete', $this->getFrete());  
        $this->smarty->assign('despacessorias', $this->getDespAcessorias());  
        $this->smarty->assign('seguro', $this->getSeguro());
        
        
        
        /*
         * Nota Fiscal Produtos
         */
//       if (($this->m_opcao == 'produto') || ($this->m_opcao == 'receber')){
        $idNf = $this->getId();
        if (is_numeric($idNf)){
            $NfProdutoOBJ = new c_nota_fiscal_produto();
            $NfProdutoOBJ->setIdNf($this->getId());
            $lancProd = $NfProdutoOBJ->select_nota_fiscal_produto_nf();
            $this->smarty->assign('lancProd', $lancProd);
       }
        
        
        $this->smarty->display('nota_fiscal_cadastro.tpl');
    }

//fim desenhaCadastroNotaFiscal
//---------------------------------------------------------------
//---------------------------------------------------------------
    function mostraNotaFiscal($mensagem=NULL,  $tipoMsg = NULL, $file='') {        
        
        if ($this->m_letra != '') {

            $lanc = $this->select_nota_fiscal_letra($this->m_letra);
        }
        if ((is_null($this->m_par[3]) or ($this->m_par[3]=='')) and (is_null($this->m_par[4]))  or ($this->m_par[4]=='')){
            $emailBody = "";
            $emailTitulo = "";            
            $emailContador = "";
        } else {
          $emailBody = "Você está recebendo os XML's das Notas Fiscais Eletrônica emitidas em ".$this->m_par[3]." até ".$this->m_par[4].".";
          $emailTitulo ="Nfe - período de ".$this->m_par[3]." até ".$this->m_par[4];
          
          $consulta = new c_banco();
          $sql  = "SELECT EMAIL FROM fin_cliente c ";
          $sql .= "LEFT JOIN fin_classe cla on (cla.classe=c.classe) ";
          $sql .= "WHERE cla.descricao = 'CONTABILIDADE' LIMIT 1 ";
          $consulta->exec_sql($sql);
          $consulta->close_connection();
          $result = $consulta->resultado;
          $emailContador = $result[0]['EMAIL']; 
        }
        $this->smarty->assign('emailCorpo', $emailBody);
        $this->smarty->assign('emailTitulo',$emailTitulo);
        $this->smarty->assign('emailContador',$emailContador);
        $this->smarty->assign('pathImagem', $this->img);
        $this->smarty->assign('pathCliente', ADMhttpCliente);
        $this->smarty->assign('mensagem', $mensagem);
        $this->smarty->assign('tipoMsg', $tipoMsg);
        $this->smarty->assign('letra', $this->m_letra);
        $this->smarty->assign('subMenu', $this->m_submenu);
        $this->smarty->assign('opcao', $this->m_opcao);
        $this->smarty->assign('lanc', $lanc);
        $this->smarty->assign('numNf', $this->m_par[5]);

        $this->smarty->assign('arquivo', $file);
        $this->smarty->assign('nomeArq', basename($file));        
        
        if ($this->m_par[3] == "")
            $this->smarty->assign('dataIni', date("01/m/Y"));
        else
            $this->smarty->assign('dataIni', $this->m_par[3]);

        if ($this->m_par[4] == "") {
            $dia = date("d");
            $mes = date("m");
            $ano = date("Y");
            $data = mktime(0, 0, 0, $mes + 1, 0, $ano);
            $this->smarty->assign('dataFim', date("d/m/Y", $data));
        } else
            $this->smarty->assign('dataFim', $this->m_par[4]);


        // filial
        $consulta = new c_banco();
        $sql = "select centrocusto as id, descricao from fin_centro_custo where (ativo='S')";
        $consulta->exec_sql($sql);
        $consulta->close_connection();
        $result = $consulta->resultado;
        for ($i = 0; $i < count($result); $i++) {
            $filial_ids[$i] = $result[$i]['ID'];
            $filial_names[$i] = $result[$i]['DESCRICAO'];
        }
        $this->smarty->assign('filial_ids', $filial_ids);
        $this->smarty->assign('filial_names', $filial_names);
        if(isset($this->m_par[0]) == ''){
            $this->smarty->assign('filial_id',  $this->m_empresacentrocusto);
        }else{
            $this->smarty->assign('filial_id',  $this->m_par[0]);
        }
        

        // tipo
        $consulta = new c_banco();
        $sql = "select tipo as id, padrao as descricao from amb_ddm where (alias='EST_MENU') and (campo='TipoNotaFiscal')";
        $consulta->exec_sql($sql);
        $consulta->close_connection();
        $result = $consulta->resultado;
        $tipo_ids[0] = "";
        $tipo_names[0] = 'Todos';
        for ($i = 0; $i < count($result); $i++) {
            $tipo_ids[$i + 1] = $result[$i]['ID'];
            $tipo_names[$i + 1] = $result[$i]['DESCRICAO'];
        }
        $this->smarty->assign('tipo_ids', $tipo_ids);
        $this->smarty->assign('tipo_names', $tipo_names);
        if ($this->m_par[1] == "")
            $this->smarty->assign('tipo_id', '1');
        else
            $this->smarty->assign('tipo_id', $this->m_par[1]);

        //sql para mostrar a situacao no combobox
        $consulta = new c_banco();
        $sql = "select tipo as id, padrao as descricao from amb_ddm where (alias='EST_MENU') and (campo='SituacaoNota')";
        $consulta->exec_sql($sql);
        $consulta->close_connection();
        $result = $consulta->resultado;
        $situacao_ids[0] = 0;
        $situacao_names[0] = 'Todas';
        for ($i = 0; $i < count($result); $i++) {
            $situacao_ids[$i + 1] = $result[$i]['ID'];
            $situacao_names[$i + 1] = $result[$i]['DESCRICAO'];
        }
        $this->smarty->assign('situacao_ids', $situacao_ids);
        $this->smarty->assign('situacao_names', $situacao_names);
        if ($this->m_par[2] == "")
            $this->smarty->assign('situacao_id', 'B');
        else
            $this->smarty->assign('situacao_id', $this->m_par[2]);
             
        $this->smarty->display('nota_fiscal_mostra.tpl');
    }



    function buscarNotasFiscais($letra) {
        $par = explode("|", $letra);
        $sql = "SELECT * ";
        $sql .= "FROM est_nota_fiscal ";
        if (!empty($par[0])) {
            if (!$isWhere) {
                $sql .= "WHERE ";
                $isWhere = true;
            } else {
                $sql .= "AND ";
            }
            $sql .= "(descricao like '" . $par[0] . "%') ";
        }
        if (!empty($par[1])) {
            if (!$isWhere) {
                $sql .= "WHERE ";
                $isWhere = true;
            } else {
                $sql .= "AND ";
            }
            $sql .= "(grupo = '" . $par[1] . "') ";
        }

        if ($par[2] == 'S') {
            if (!$isWhere) {
                $sql .= "WHERE ";
                $isWhere = true;
            } else {
                $sql .= "AND ";
            }
            $sql .= "((iniciopromocao <= '" . $data . "') and (fimpromocao >= '" . $data . "'))";
        }
        //echo strtoupper($sql)."<BR>";

        $banco = new c_banco;
        $banco->exec_sql($sql);
        $banco->close_connection();
        return $banco->resultado;
    } //buscarNotaFiscais
    
    function comprimir($caminho){
        $caminho = realpath($caminho);
        $arquivo = $caminho.'.zip';
        $zip = new ZipArchive();
        $zip->open($arquivo, ZipArchive::CREATE | ZipArchive::OVERWRITE);
        $arquivos = new RecursiveIteratorIterator(
            new RecursiveDirectoryIterator($caminho),
            RecursiveIteratorIterator::LEAVES_ONLY
        );    
        foreach ($arquivos as $name => $file) {
            if (!$file->isDir()) {
                $file_path = $file->getRealPath();
                $relative_path = substr($file_path, strlen($caminho) + 1);
                $zip->addFile($file_path, $relative_path);
            }
        }
        $zip->close();
        return $arquivo;       
    }
    
   
    public function enviarEmailXML($email, $title, $body, $cc=null, $dhIni, $dhFim, $fileName01, $fileName02 = null) {
        
        try {
            if (is_null($email) or ($email=='')) {
                return 'Email envio não cadastrado';                
            } else {    
                if (is_null($email)  or ($email=='')) {
                    $aMails = array($cc); //se for um array vazio a classe Mail irá pegar os emails do xml
                }
            }
            
            if (is_null($fileName02)){
              $fileName02 = $fileName01;  
            }
            
            $mail = new admMail;
            
            $result = $mail->SendMail($this->m_configsmtp, $this->m_configemail, "email Nfe", $this->m_configemailsenha, 
                               $body, $title , $email, "",$cc,"", $fileName01, $fileName02);


            if (strstr($result, 'não')){
                return "email XML's NÃO enviado - entre em contato com o suporte";
            } else {   
                return true;
            }
    
        } catch (Exception $e) {
            return 'Erro -> '.$e->getMessage();
        }
    }


//fim mostraNotaFiscal
//-------------------------------------------------------------
}



//	END OF THE CLASS
// Rotina principal - cria classe
$NotaFiscal = new p_nota_fiscal();

$NotaFiscal->controle();
?>
